package acopComa;

import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Event;
import java.awt.BorderLayout;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.KeyStroke;
import java.awt.Point;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JFrame;
import javax.swing.JDialog;
import coma.*;

public class AcopComa
{
  private JFrame jFrame = null;
  private JPanel jContentPane = null;
  private JMenuBar jJMenuBar = null;
  private JMenu fileMenu = null;
  private JMenu editMenu = null;
  private JMenu helpMenu = null;
  private JMenuItem exitMenuItem = null;
  private JMenuItem aboutMenuItem = null;
  private JMenuItem cutMenuItem = null;
  private JMenuItem copyMenuItem = null;
  private JMenuItem pasteMenuItem = null;
  private JMenuItem saveMenuItem = null;
  private JDialog aboutDialog = null;
  private JPanel aboutContentPane = null;
  private JLabel aboutVersionLabel = null;
  /**
   * This method initializes jFrame
   * 
   * @return javax.swing.JFrame
   */
  private JFrame getJFrame()
  {
    if (jFrame == null)
    {
      jFrame = new JFrame();
      jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      jFrame.setJMenuBar(getJJMenuBar());
      jFrame.setSize(300, 200);
      jFrame.setContentPane(getJContentPane());
      jFrame.setTitle("Application");
      new Coma(jFrame);
    }
    return jFrame;
  }
  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getJContentPane()
  {
    if (jContentPane == null)
    {
      jContentPane = new JPanel();
      jContentPane.setLayout(new BorderLayout());
    }
    return jContentPane;
  }
  /**
   * This method initializes jJMenuBar	
   * 	
   * @return javax.swing.JMenuBar	
   */
  private JMenuBar getJJMenuBar()
  {
    if (jJMenuBar == null)
    {
      jJMenuBar = new JMenuBar();
      jJMenuBar.add(getFileMenu());
      jJMenuBar.add(getEditMenu());
      jJMenuBar.add(getHelpMenu());
    }
    return jJMenuBar;
  }
  /**
   * This method initializes jMenu	
   * 	
   * @return javax.swing.JMenu	
   */
  private JMenu getFileMenu()
  {
    if (fileMenu == null)
    {
      fileMenu = new JMenu();
      fileMenu.setText("File");
      fileMenu.add(getSaveMenuItem());
      fileMenu.add(getExitMenuItem());
    }
    return fileMenu;
  }
  /**
   * This method initializes jMenu	
   * 	
   * @return javax.swing.JMenu	
   */
  private JMenu getEditMenu()
  {
    if (editMenu == null)
    {
      editMenu = new JMenu();
      editMenu.setText("Edit");
      editMenu.add(getCutMenuItem());
      editMenu.add(getCopyMenuItem());
      editMenu.add(getPasteMenuItem());
    }
    return editMenu;
  }
  /**
   * This method initializes jMenu	
   * 	
   * @return javax.swing.JMenu	
   */
  private JMenu getHelpMenu()
  {
    if (helpMenu == null)
    {
      helpMenu = new JMenu();
      helpMenu.setText("Help");
      helpMenu.add(getAboutMenuItem());
    }
    return helpMenu;
  }
  /**
   * This method initializes jMenuItem	
   * 	
   * @return javax.swing.JMenuItem	
   */
  private JMenuItem getExitMenuItem()
  {
    if (exitMenuItem == null)
    {
      exitMenuItem = new JMenuItem();
      exitMenuItem.setText("Exit");
      exitMenuItem.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          System.exit(0);
        }
      });
    }
    return exitMenuItem;
  }
  /**
   * This method initializes jMenuItem	
   * 	
   * @return javax.swing.JMenuItem	
   */
  private JMenuItem getAboutMenuItem()
  {
    if (aboutMenuItem == null)
    {
      aboutMenuItem = new JMenuItem();
      aboutMenuItem.setText("About");
      aboutMenuItem.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          JDialog aboutDialog = getAboutDialog();
          aboutDialog.pack();
          Point loc = getJFrame().getLocation();
          loc.translate(20, 20);
          aboutDialog.setLocation(loc);
          aboutDialog.setVisible(true);
        }
      });
    }
    return aboutMenuItem;
  }
  /**
   * This method initializes aboutDialog	
   * 	
   * @return javax.swing.JDialog
   */
  private JDialog getAboutDialog()
  {
    if (aboutDialog == null)
    {
      aboutDialog = new JDialog(getJFrame(), true);
      aboutDialog.setTitle("About");
      aboutDialog.setContentPane(getAboutContentPane());
    }
    return aboutDialog;
  }
  /**
   * This method initializes aboutContentPane
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getAboutContentPane()
  {
    if (aboutContentPane == null)
    {
      aboutContentPane = new JPanel();
      aboutContentPane.setLayout(new BorderLayout());
      aboutContentPane.add(getAboutVersionLabel(), BorderLayout.CENTER);
    }
    return aboutContentPane;
  }
  /**
   * This method initializes aboutVersionLabel	
   * 	
   * @return javax.swing.JLabel	
   */
  private JLabel getAboutVersionLabel()
  {
    if (aboutVersionLabel == null)
    {
      aboutVersionLabel = new JLabel();
      aboutVersionLabel.setText("Version 1.0");
      aboutVersionLabel.setHorizontalAlignment(SwingConstants.CENTER);
    }
    return aboutVersionLabel;
  }
  /**
   * This method initializes jMenuItem	
   * 	
   * @return javax.swing.JMenuItem	
   */
  private JMenuItem getCutMenuItem()
  {
    if (cutMenuItem == null)
    {
      cutMenuItem = new JMenuItem();
      cutMenuItem.setText("Cut");
      cutMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, Event.CTRL_MASK, true));
    }
    return cutMenuItem;
  }
  /**
   * This method initializes jMenuItem	
   * 	
   * @return javax.swing.JMenuItem	
   */
  private JMenuItem getCopyMenuItem()
  {
    if (copyMenuItem == null)
    {
      copyMenuItem = new JMenuItem();
      copyMenuItem.setText("Copy");
      copyMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, Event.CTRL_MASK, true));
    }
    return copyMenuItem;
  }
  /**
   * This method initializes jMenuItem	
   * 	
   * @return javax.swing.JMenuItem	
   */
  private JMenuItem getPasteMenuItem()
  {
    if (pasteMenuItem == null)
    {
      pasteMenuItem = new JMenuItem();
      pasteMenuItem.setText("Paste");
      pasteMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK, true));
    }
    return pasteMenuItem;
  }
  /**
   * This method initializes jMenuItem	
   * 	
   * @return javax.swing.JMenuItem	
   */
  private JMenuItem getSaveMenuItem()
  {
    if (saveMenuItem == null)
    {
      saveMenuItem = new JMenuItem();
      saveMenuItem.setText("Save");
      saveMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, Event.CTRL_MASK, true));
    }
    return saveMenuItem;
  }
  /**
   * Launches this application
   */
  public static void main(String[] args)
  {
    SwingUtilities.invokeLater(new Runnable()
    {
      public void run()
      {
        AcopComa application = new AcopComa();
        application.getJFrame().setVisible(true);
      }
    });
  }
}
