/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of Java-Common.
 *
 * Java-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Java-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Java-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.application.state.impl;

import com.cosylab.application.state.StateStorage;

import java.io.IOException;


/**
 * This class is an implementation of the <code>StateStorage</code> that uses
 * the CDB server to store the array of the <code>State</code> objects.
 *
 * @author dvitas
 */
public class CDBStateStorage extends XMLStateStorage
{
	/**
			 *
			 */
	public CDBStateStorage()
	{
		super();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param other
	 */
	public CDBStateStorage(StateStorage other)
	{
		super(other);
	}

	/* (non-Javadoc)
	 * @see com.cosylab.application.state.StateStorage#load(java.io.InputStream)
	 */
	@Override
    public void load(String filePath, String applicationName)
		throws IOException
	{
		System.err.println("CDB is not activated. Using the base class!");
		super.load(filePath, applicationName);

		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see com.cosylab.application.state.StateStorage#store(java.io.OutputStream)
	 */
	@Override
    public void store(String filePath, String applicationName)
		throws IOException
	{
		System.err.println("CDB is not activated. Using the base class!");
		super.store(filePath, applicationName);

		// TODO Auto-generated method stub
	}
}

/* __oOo__ */
