package com.cosylab.cosydist.ant;

import java.io.File;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import com.cosylab.cosydist.LicenseHeaderExecutor;
import com.cosylab.cosydist.Logger;

public class HeadCheck extends Task {
	private File licenseFile = null;
	private boolean debug = false;
	public void execute() throws BuildException {
		String srcString = getProject().getProperty("src");
		if (srcString == null) {
			throw new BuildException("<src>String</src> tag must be defined");
		}
		String[] src = srcString.replaceAll(";", " ").replaceAll("  ", " ").split(" ");
		LicenseHeaderExecutor.attachLicense(src, licenseFile, new Logger(), true, debug, debug);
	}
	
	public void setLicenseFile(String s){
		if (s == null || s.equals("")) return;
		this.licenseFile = new File(s);
	}
	
	public void setDebug(boolean b){
		this.debug = b;
	}
}
