/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import com.cosylab.gui.components.customizer.AbstractCustomizerPanel;

/**
 * Customizer for <code>ButtonController</code>.
 * 
 * @author <a href="mailto:blaz.hostnik@cosylab.com">Blaz Hostnik, Cosylab</a>
 * @see ButtonController
 */
public class ButtonControllerCustomizer extends AbstractCustomizerPanel {
	private static final long serialVersionUID = 1L;

	/** Title of the visual settings tab. */
	public static final String VISUAL = "Visual";
	
	/** Tag for title property */
	public static final String TEXT = "text";
	
	/** Tag for title property */
	public static final String BACKGROUND = "background";	

	/** Names of the visual properties. */
	public static String[] VISUAL_PROPERTIES = { TEXT, BACKGROUND};	
	
	/** Title of the visual settings tab. */
	public static final String ACTION = "Action";
	
	/** Tag for action value property */
	public static final String ACTION_VALUE = "actionValue";
	
	/** Names of the visual properties. */
	public static String[] ACTION_PROPERTIES = { ACTION_VALUE};
	
	/**
	 * Constructs new WheelswitchDisplayerCustomizer.
	 *
	 */
	public ButtonControllerCustomizer() {
		setSize(479, 325);
		addCustomizerTable(VISUAL, VISUAL_PROPERTIES);
		addCustomizerTable(ACTION, ACTION_PROPERTIES);
	}

}
