/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import com.cosylab.gui.adapters.ConverterCustomizer;
import com.cosylab.gui.components.AbstractNumericDisplayerPanelCustomizer;

/**
 * <code>DoubleNumberDisplayerCustomizer</code> is a customizer for 
 * <code>DoubleNumberDisplayer</code> which includes the {@link ConverterCustomizer}.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: DoubleNumberDisplayerCustomizer.java,v 1.6 2008-04-22 12:31:02 jbobnar Exp $
 * @see DoubleNumberDisplayer
 */
public class DoubleNumberDisplayerCustomizer extends AbstractNumericDisplayerPanelCustomizer {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Constructs new DoubleNubmerDisplayerCustomizer.
	 *
	 */
	public DoubleNumberDisplayerCustomizer() {
		addCustomizerTable("Value Display/Bounds", new String[]{"minimum", "maximum"});
		addCustomizer("Converter", new ConverterCustomizer());
		setSize(528, 325);
	}
}
