/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import com.cosylab.gui.adapters.ConverterCustomizer;
import com.cosylab.gui.components.LabelledGaugerCustomizer;

/**
 * <code>GaugerDisplayerCustomizer</code> is a customizer for
 * <code>GaugerDisplayer</code> which includes the {@link ConverterCustomizer}.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: GaugerDisplayerCustomizer.java,v 1.8 2008-04-22 12:31:02 jbobnar Exp $
 * @see GaugerDisplayer
 */
public class GaugerDisplayerCustomizer extends LabelledGaugerCustomizer {
	private static final long serialVersionUID = 1L;

	/**
	 * Constructs a new GaugerDisplayerCustomizer.
	 *
	 */
	public GaugerDisplayerCustomizer() {
		addCustomizer("Converters", new ConverterCustomizer()); 
		setSize(450, 350);
	}
}
