/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import java.awt.Image;
import java.beans.IntrospectionException;

import com.cosylab.gui.components.util.ImageHelper;
import com.cosylab.util.BeanInfoSupport;

/**
 * <code>BeanInfo</code> for <code>IconDisplayer</code>.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: IconDisplayerBeanInfo.java,v 1.15 2008-04-22 12:31:02 jbobnar Exp $
 * @see IconDisplayer
 */
public class IconDisplayerBeanInfo extends BeanInfoSupport {
	
	/**
	 * COnstructs new IconDisplayerBeanInfo.
	 * 
	 * @throws IntrospectionException
	 */
	public IconDisplayerBeanInfo() throws IntrospectionException {
		super();
		loadDefaultPropertyDescriptors();
		setBeanDescriptor(IconDisplayerCustomizer.class);
		loadPropertyDescriptors(IconDisplayerCustomizer.VISUAL_BASIC_PROPERTIES);
		removePropertyDescriptor("dataState");
		removePropertyDescriptor("dataSource");
		loadPropertyDescriptor("icons", ValueIconPropertyEditor.class);
		loadPropertyDescriptor("defaultIconName", IconPropertyEditor.class);
		removePropertyDescriptor("defaultIcon");
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.beans.SimpleBeanInfo#getIcon(int)
	 */
	@Override
    public Image getIcon(int iconKind) {
		return ImageHelper.createImage("icons/components/IconDisplayer16.gif");
	}
}
