/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

import com.cosylab.gui.components.customizer.AbstractCustomizerPanel;

/**
 * <code>AbstractDisplayerPanelCustomizer</code> is a default costomizer employed
 * by AbstractDisplayerPanel.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: AbstractDisplayerPanelCustomizer.java,v 1.6 2008-04-22 12:28:40 jbobnar Exp $
 *
 */
public abstract class AbstractDisplayerPanelCustomizer extends AbstractCustomizerPanel {

	private static final long serialVersionUID = 1L;

	/** Title of the basic visual settings tab. */
	public static final String VISUAL_BASIC = "Visual";

	/** Title of the visual tab. */
	public static final String VISUAL_LAYOUT = "Visual/Layout";

	/** Tag for resizable property. */
	public static final String RESIZABLE = "resizable";

	/** Tag fot titleVisible property */
	public static final String TITLE_VISIBLE = "titleVisible";

	/** Tag for title property */
	public static final String TITLE = "title";

	/** Title maximum font size property constant */
	public static final String MIN_TITLE_FONT_SIZE = "titleMinimumFontSize";

	/** Title minimum font size property constant */
	public static final String MAX_TITLE_FONT_SIZE = "titleMaximumFontSize";

	/** The layout orientation property name */
	public static final String LAYOUT_ORIENTATION_PROPERTY = "layoutType";
		
	/** Names of the basic visual properties. */
	public static String[] VISUAL_BASIC_PROPERTIES = { TITLE, TITLE_VISIBLE,
			MIN_TITLE_FONT_SIZE, MAX_TITLE_FONT_SIZE, RESIZABLE,
			LAYOUT_ORIENTATION_PROPERTY};

	/** Supported aspects. */
	public static String[] ASPECTS = { VISUAL_BASIC, VISUAL_LAYOUT };

	
	public AbstractDisplayerPanelCustomizer() {
		addCustomizerTable(VISUAL_BASIC, VISUAL_BASIC_PROPERTIES);
		setSize(400, 400);
	}

}
