/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

import java.awt.Color;

import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;


/**
 * Border with tile and thin line.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public class GroupBoxBorder extends TitledBorder
{
	private static final long serialVersionUID = 1L;

	/**
	 * Creates a new GroupBoxBorder object.
	 */
	public GroupBoxBorder()
	{
		super(new LineBorder(Color.black));
	}

	/**
	 * Creates border with specificed title.
	 *
	 * @param title
	 */
	public GroupBoxBorder(String title)
	{
		this();
		setTitle(title);
	}
}

/* __oOo__ */
