/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

public class LabelledLedderCustomizer extends AbstractDisplayerPanelCustomizer {

	private static final long serialVersionUID = 1L;


	/** ReversLedsOrder field property name. */
	public static final String REVERSE_LEDS_ORDER = "reverseLedsOrder";
	

	/** Edited number field property name. */
	public static final String ENHANCED = "enhanced";
	
	/** DOCUMENT ME! */
	public static final String VALUE_DISPLAY = "Value Display";
	/** Edited number field property list. */
	public static String[] VALUE_DISPLAY_PROPERTIES = {
		REVERSE_LEDS_ORDER
	};
	
	/** Edited number field property list. */
	public static final String[] VISUAL_BASIC_PROPERTIES = {
		TITLE, TITLE_VISIBLE, MIN_TITLE_FONT_SIZE, MAX_TITLE_FONT_SIZE, RESIZABLE, ENHANCED
	};
	/** Active aspects. */
	public static String[] ASPECTS = {
		VISUAL_BASIC, VISUAL_LAYOUT, VALUE_DISPLAY
	};
	
	public LabelledLedderCustomizer() {
		addCustomizerTable(VALUE_DISPLAY, VALUE_DISPLAY_PROPERTIES);
		setSize(400, 200);
	}

}
