/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

import java.awt.Image;
import java.beans.IntrospectionException;

import com.cosylab.gui.components.util.ImageHelper;

/**
 * <code>BeanInfo</code> for <code>LabelledNumberField</code>.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: LabelledNumberFieldBeanInfo.java,v 1.8 2008-04-22 12:28:40 jbobnar Exp $
 * @see LabelledNumberField
 */
public class LabelledNumberFieldBeanInfo extends AbstractNumericDisplayerPanelBeanInfo {
			
	/**
	 * Constructs a new LabelledNumberFieldBeanInfo.
	 * 
	 * @throws IntrospectionException
	 */
	public LabelledNumberFieldBeanInfo() throws IntrospectionException {
		super();
		setBeanDescriptor(LabelledNumberFieldCustomizer.class);
		loadPropertyDescriptors(LabelledNumberFieldCustomizer.VALUE_DISPLAY_PROPERTIES);
		loadPropertyDescriptors(LabelledNumberFieldCustomizer.VISUAL_BASIC_PROPERTIES);
		loadPropertyDescriptors(LabelledNumberFieldCustomizer.VALUE_DISPLAY_BOUNDS_PROPERTIES);
		removePropertyDescriptor("state");
	}
		
	/*
	 * (non-Javadoc)
	 * @see java.beans.SimpleBeanInfo#getIcon(int)
	 */
	@Override
	public Image getIcon(int iconKind) {
		return ImageHelper.createImage("icons/components/NumberField16.gif");
	}
}
