/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

import com.cosylab.gui.components.customizer.AbstractCustomizerPanel;

public class SimpleTimeSelectorCustomizer extends
	AbstractCustomizerPanel {

	private static final long serialVersionUID = 1L;
	
	/** Tag for timeZone property. */
	public static final String  TIME_ZONE="timeZone";
	/** Tag for hour property. */
	public static final String  HOUR ="hour";
	/** Tag for minute property. */
	public static final String  MINUTE="minute";
	/** Tag for seconds property. */
	public static final String  SECONDS="seconds";
	/** Tag for time property. */
	public static final String  TIME="time";
	/** Tag for hourStatus property. */
	public static final String  HOUR_STATUS="hourStatus";
	
	public static final String LABELS_EDIT ="Other";
	/** Aspects */
    public static String[] ASPECTS = {AbstractDisplayerPanelCustomizer.VISUAL_BASIC , LABELS_EDIT};
	/** Names of the basic visual properties. */
	public static final String[] VISUAL_BASIC_PROPERTIES = {
		TIME,HOUR,MINUTE,SECONDS,TIME_ZONE 
					
	};
	
	public static final String[] LABELS_EDIT_GROUP={HOUR_STATUS};
	
	public SimpleTimeSelectorCustomizer(){
		addCustomizerTable(LABELS_EDIT, LABELS_EDIT_GROUP);
		addCustomizerTable(AbstractDisplayerPanelCustomizer.VISUAL_BASIC, VISUAL_BASIC_PROPERTIES);
		setSize(303, 185);
	}

}
