/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.customizer;

import java.beans.Customizer;
import java.beans.PropertyDescriptor;

import com.cosylab.gui.components.introspection.PropertiesTable;


/**
 * <code>PropertiesTableCustomizer</code> is a Customizer which lists 
 * all properties in a two column table. One column represents the names
 * of the properties and the other one hold the settable values. 
 * 
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public class PropertiesTableCustomizer extends PropertiesTable implements
		Customizer {

	private static final long serialVersionUID = 1L;

	/**
	 * Creates new instance of PropertiesTableCustomizer.
	 */
	public PropertiesTableCustomizer() {
		super();
		initialize();
	}
	
	/**
	 * Creates new instance of PropertiesTableCustomizer.
	 */
	public PropertiesTableCustomizer(Object bean) {
		super();
		setObject(bean);
		initialize();
	}
	
	/**
	 * Creates new instance of PropertiesTableCustomizer.
	 */
	public PropertiesTableCustomizer(String[] properties) {
		super(properties);
		initialize();
	}

	/**
	 * Creates new instance of PropertiesTableCustomizer.
	 */
	public PropertiesTableCustomizer(PropertyDescriptor[] properties) {
		super(properties);
		initialize();
	}

	/* (non-Javadoc)
	 * @see java.beans.Customizer#setObject(java.lang.Object)
	 */
	public void setObject(Object bean) {
		try {
			setBean(bean);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void initialize() {
		
/*		setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
		setPreferredSize(new Dimension(100,100));
		setMinimumSize(new Dimension(100,100));
*/	}

}
