/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.ledder;

import java.awt.Component;
import java.awt.Graphics;

import javax.swing.border.BevelBorder;

/*Custom border is extended from BevelBorder and overides the 
 * paintRaisedBevel method for optimal displaying leds
 */

public class CustomBorder extends BevelBorder {
	private static final long serialVersionUID = 1L;
	private boolean visible=true;

	public CustomBorder(){
		super(RAISED);
	}
	
	@Override
    protected void paintRaisedBevel(Component c, Graphics g, int x, int y,
		                            int width, int height) {
		 if (visible) {
			 super.paintRaisedBevel(c,g,x,y,width,height);
		 }
	}

	/**
	 * @return Returns the visible.
	 */
	public boolean isVisible() {
		return visible;
	}

	/**
	 * @param visible The visible to set.
	 */
	public void setVisible(boolean visible) {
		
		this.visible = visible;
	}
	
	
}
