/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.numberfield;


/**
 * This is the implementation of the <code>AbstractNumberDocument</code> class
 * implementing the integer parser.
 * 
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a>
 * @version $id$
 */
public class IntegerDocument extends AbstractNumberDocument {


	private static final long serialVersionUID = 1L;

	/**
	 * Constructor for IntegerDocument.
	 */
	public IntegerDocument() {
		super();
	}

	/**
	 * Parses the string as integer.
	 * 
	 * @param s String
	 * @return Number
	 * @see AbstractNumberDocument#parseNumber(String)
	 */
	@Override
	protected Number parseNumber(String s) {
		Integer value = null;

		try {
			value = new Integer(s);

		} catch (NumberFormatException e) {
			value = null;
		}

		return value;
	}
}
