/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.numberfield;


/**
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 * 
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a>
 * @version $id$
 */
public class LongDocument extends AbstractNumberDocument {

	private static final long serialVersionUID = 1L;

	/**
	 * Constructor for LongDocument.
	 */
	public LongDocument() {
		super();
	}

	/**
	 * @see AbstractNumberDocument#parseNumber(String)
	 */
	@Override
	protected Number parseNumber(String s) {
		
		Long value = null;

		try {
			if ("-".equals(s.trim())) {
				value=null;
			} else {
				value = new Long(s);
			}
			
		} catch (NumberFormatException e) {
			value = null;
		}
		
		return value;
	}

}
