/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.numberfield;

/**
 * Document, which delegates parsing to <code>NumberDescriptor</code>.
 * @author ikriznar
 */
public class NumberDescriptorDocument extends AbstractNumberDocument {

	private static final long serialVersionUID = 1L;
	private NumberDescriptor descriptor;
	/**
	 * Creates new instance. 
	 */
	public NumberDescriptorDocument() {
		super();
	}

	/* (non-Javadoc)
	 * @see com.cosylab.gui.components.numberfield.AbstractNumberDocument#parseString(java.lang.String)
	 */
	@Override
	protected Number parseNumber(String s) {
		return getDescriptor().parseNumber(s);
	}

	/**
	 * Returns the NumberDescriptor delegate.
	 * 
	 * @return
	 */
	public NumberDescriptor getDescriptor() {
		if (descriptor==null) {
			descriptor= new DefaultNumberDescriptor();
		}
		return descriptor;
	}
	
	/**
	 * Sets the NumberDescriptor delegate.
	 * 
	 * @param descriptor
	 */
	public void setDescriptor(NumberDescriptor descriptor) {
		this.descriptor = descriptor;
	}
}
