package com.cosylab.gui.components.range2;

/**
 * 
 * <code>PeriodicValuePolicy</code> is a policy, where the value is trimmed to minimum
 * if it is higher than maximum and trimmed to maximum if it is lower than minimum.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public class PeriodicValuePolicy extends RangedValuePolicy {
	
	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.components.range2.RangedValuePolicy#validate(com.cosylab.gui.components.range2.RangedValue)
	 */
	@Override
	public RangedValue validate(RangedValue params) {
		double val = params.getValue();
		double min = params.getMinimum();
		double max = params.getMaximum();
		if (val > max) {
			val = min;
		}
		if (val < min) {
			val = max;
		}
		return new RangedValue(min,max,val);
	}
}
