/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.table.cells;

/**
 * Command is interface for wraper aroud action, whcih can be performed with
 * arbitrary table cell. Calling <code>execute</code> on cell directly
 * executes the action.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public interface Command
{
	public String getName();
	/**
	 * Executes by this command 
	 *
	 * @param originator the table cell, from which command was on which command was executed
	 *
	 * @throws CommandException DOCUMENT ME!
	 */
	public void execute(TableCell originator) throws CommandException;
}

/* __oOo__ */
