/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.table.cells;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;



/**
 * Action, which executes command.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 */
public class CommandAction extends AbstractAction
{
	private static final long serialVersionUID = 1L;
	private Command command;
	private TableCell cell;

	/**
	 * Constructs a new CommandAction that belongs to a specific cell and can
	 * execute the given command.
	 * 
	 * @param command executable command
	 * @param cell owner of the action
	 */
	public CommandAction(Command command, TableCell cell)
	{
		super(command.getName());

		this.command = command;
		this.cell = cell;
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e)
	{
		try {
			command.execute(cell);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}

/* __oOo__ */
