/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.table.cells;

/**
 * DobubleSeqCell hold double array value.
 * 
 * @author jkamenik
 */
public class DoubleSeqCell extends NumericCell {

	/**
	 * Constructs a new DoubleSeqCell.
	 *
	 */
	public DoubleSeqCell() {
		super();
	}
	/**
	 * @param identifier
	 * @param dataSource
	 * @param value
	 * @param commands
	 */
	public DoubleSeqCell(String identifier, Object dataSource, Object value,
			Command[] commands) {
		super(identifier, dataSource, value, commands);
	}
	
	/**
	 * Returns the double array value.
	 * 
	 * @return
	 */
	public double[] getDoubleSeqValue() {
		return (double[]) value;
	}
	
	/**
	 * Sets the double array value 
	 * 
	 * @param num new double array
	 */
	public void setDoubleSeqValue(double[] num) {
		super.setValue(num);
	}
	
}
