/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.table.cells;

/**
 * LongCell  holds <code>long</code> type of value.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public class LongCell extends NumericCell
{
	/**
	 * Constructs a new LongCell object.
	 *
	 */
	public LongCell()
	{
		super();
		//setting default value to avoid null pointer
		setValue(0);
	}

	/**
	 * Constructs a new LongCell object.
	 *
	 * @param identifier
	 * @param dataSource
	 * @param value
	 * @param commands
	 */
	public LongCell(String identifier, Object dataSource, long value,
	    Command[] commands)
	{
		super(identifier, dataSource, new Long(value), commands);
	}

	/**
	 * Returnst the long value of this cell.
	 * 
	 * @return the value
	 */
	public long getLongValue()
	{
		return ((Number)value).longValue();
	}

	/**
	 * Sets the long value to this cell.
	 * 
	 * @param newValue new long value
	 */
	public void setValue(long newValue)
	{
		setValue(new Long(newValue));
	}
}

/* __oOo__ */
