/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.util;

import java.awt.Component;
import java.awt.Container;
import java.awt.event.MouseMotionListener;

import javax.swing.JComponent;
import javax.swing.TransferHandler;

public class DnDUtil {

	public static void setTransferHandler(TransferHandler th, JComponent component) {
		component.setTransferHandler(th);
		
		if (th instanceof MouseMotionListener) {
			recursiveGetChild(component,(MouseMotionListener)th);
		}
	}
	
	private static void recursiveGetChild(Component component, MouseMotionListener l) {
		if (component instanceof Container) {
			Component[] comp = ((Container)component).getComponents();
			for (Component c: comp) {
				recursiveGetChild(c,l);
			}
		}
		component.addMouseMotionListener(l);		
	}
	
}


/* __oOo__ */
