/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.util;

import com.cosylab.util.BeanInfoSupport;

import java.awt.Image;

import java.beans.PropertyDescriptor;
import java.beans.SimpleBeanInfo;


/**
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 *
 * @author <a href="mailto:igor.verstovsek@cosylab.com">Igor Verstovsek</a>
 */
public class ImagePanelBeanInfo extends SimpleBeanInfo {
    private PropertyDescriptor[] propertyDescriptors = null;

    /* (non-Javadoc)
     * @see java.beans.BeanInfo#getIcon(int)
     */
    @Override
    public Image getIcon(int iconKind) {
        return ImageHelper.createImage(
            "icons/components/ImagePanel16.gif");
    }

    /* (non-Javadoc)
     * @see java.beans.BeanInfo#getPropertyDescriptors()
     */
    @Override
    public PropertyDescriptor[] getPropertyDescriptors() {
        if (propertyDescriptors == null) {
            propertyDescriptors = BeanInfoSupport.getPropertyDescriptors(ImagePanel.class);

            for (int i = 0; i < propertyDescriptors.length; i++) {
                if (propertyDescriptors[i].getName().equals("imageName")) {
                    propertyDescriptors[i].setPreferred(true);
                    propertyDescriptors[i].setShortDescription(
                        "The name of the picture to be displayed.");

                    break;
                }
            }
        }

        return propertyDescriptors;
    }
}
