/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.displayers;

import java.beans.PropertyVetoException;

import com.cosylab.gui.adapters.Converter;

/**
 * <code>ConvertibleDisplayer</code> enables usage of Converters. It should be implemented by those 
 * DataConsumers that needs to convert the value they are receiveing from data source.
 * 
 * @author Jaka Bobnar, Cosylab
 *
 */
public interface ConvertibleDisplayer extends Displayer {
	
	public static String CONVERTER_PROPERTY="converter";
	
	/**
	 * Sets the Converter that is used when displaying value with this.
	 * 
	 * @param converter
	 */
	public void setConverter(Converter converter) throws PropertyVetoException;
	
	/**
	 * Returns the converter that is used with the displayer.
	 * 
	 * @return
	 */
	public Converter getConverter();
	
}


/* __oOo__ */
