/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.displayers;

/**
 * <code>NonblockingNumberConsumer</code> is data consumer for
 * <code>Number</code> data, which does not block or fail update request.
 * 
 * <p>
 * This interface is intended to be used by <code>DataSource</code>. Displayer
 * which want to notify data source about value changes done by user need to
 * implement <code>DataSource</code> which supports this type of consumer.
 * </p>
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: NonblockingNumberConsumer.java,v 1.3 2008-04-22 12:31:02 jbobnar Exp $
 *
 * @since Dec 3, 2003.
 */
public interface NonblockingNumberConsumer extends DataConsumer
{
	/**
	 * Notifys this consumer about new dynamic value update.
	 *
	 * @param value new value
	 */
	public void updateNonblocking(Number value);
}

/* __oOo__ */
