/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.util;

import java.awt.datatransfer.DataFlavor;

import javax.swing.JComponent;

import com.cosylab.gui.displayers.Displayer;
import com.cosylab.gui.displayers.DisplayerParameters;
import com.cosylab.gui.displayers.DoubleDisplayer;

/**
 * <code>DefaultDisplayerParametersTransferHandler</code> is a default
 * extension of {@link AbstractDisplayerParametersTransferHandler} which can handle
 * DisplayerParameters. 
 * 
 * @author tkusterle
 *
 */
public class DefaultDisplayerParametersTransferHandler extends AbstractDisplayerParametersTransferHandler {
	
	private static final long serialVersionUID = -4223198013311762602L;

	protected Displayer displayer;

	public DefaultDisplayerParametersTransferHandler(Displayer comp, boolean reciveEnabled, boolean exportEnabled) {
		super((JComponent)comp,reciveEnabled, exportEnabled);
		displayer= comp;
	}
	
	public DefaultDisplayerParametersTransferHandler(Displayer comp, boolean reciveEnabled, boolean exportEnabled, DataFlavor[] f, boolean resetFlavors) {
		super((JComponent)comp, reciveEnabled, exportEnabled, f, resetFlavors);
		displayer= comp;
	}

	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.util.AbstractDisplayerParametersTransferHandler#exportDisplayerParameters()
	 */
	@Override
    protected DisplayerParameters exportDisplayerParameters() {
 		if (displayer instanceof DoubleDisplayer) {
			return new DisplayerParameters(displayer.getTitle(),(DoubleDisplayer)displayer);
		} 
 		return new DisplayerParameters(displayer.getTitle());
	}

	/**
	 * Returns the displayer.
	 * @return Returns the displayer.
	 */
	public Displayer getDisplayer() {
		return displayer;
	}	
}
