/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.chart;
import java.awt.BasicStroke;
import java.text.DecimalFormat;

public class AcopConst
{
    protected static DecimalFormat textFormat = new DecimalFormat("#0.0000");
    protected static int  max_points = 524288;   //	8192*64
    protected static double zero_check = 1.0e-30;

    protected static int  N_TIME = 7;
    protected static int  timeMax[] = {1000, 100, 100, 100, 100, 20, 68}; // maximum 68 years for interger overflow!! 2007 hwu
    protected static double  timeScale[] = {0.001, 1, 60, 3600, 86400, 2592000, 31536000};
    protected static java.lang.String[] timeStr = {"MilliSeconds", "Seconds", "Minutes", "Hours", "Days", "Months", "Years"};
    public static int tScale_ms = 0,
                      tScale_second = 1,
                      tScale_minute = 2,
                      tScale_hour = 3,
                      tScale_day = 4,
                      tScale_month = 5,
                      tScale_year = 6;

    public static int  MAX_PERSIST = 10;    // maximum # of persistent display curves
    public static int  MAX_DISPLAY = 100;    // maximum # of curves
    protected static int  MAX_TEXT = 100;    // maximum # of text strings
    public static int  N_DEF_DISPLAY = 20;    // maximum # of curves for averaging
    protected static int  TEXT_MOVE = 3;    // x move bit 0; y move bit 1
    protected static int  lengthZoom = 20;
    protected static int  MAX_BACKGROUND_REGION = 16;
    protected static int  MAX_AXIS = 2;     // maximum # of Axis
    
    protected static int  NEW_PRINT_WINDOW = 4;
    protected static int  NEW_TEXT_WINDOW = 3;
    protected static int  NEW_ZOOM_WINDOW = 2;
    protected static int  NEW_MOVE_WINDOW = 1;

    protected static int  FFT_SPEKTRUM   = 0x1;	// spektrum + 0
    protected static int  FFT_PHASE      = 0x2;	// phase + 0
    protected static int  FFT_SP	       = 0x3;	// spektrum + phase
    protected static int  FFT_RI	       = 0x4;	// real part + imaginary part
    protected static int  FFT_REAL       = 0x5; // real part
    protected static int  FFT_IMAGINARY  = 0x6; // imaginary part
    protected static int  FFT_RI_INVERSE = 0x7; // inverse FFT for real and imaginary
    protected static int  FFT_DIFFER_STATISTIC = 0x8; // differencial statustucs
    protected static int  FFT_INTEGRAL_STATISTIC = 0x9; // integeral statistics
    protected static int  FFT_LINE_FIT = 0xa; // line fit
    protected static int  FFT_EXPONENTIAL_FIT = 0xb; // exponential fit
    protected static int  FFT_GAUSSIAN_FIT = 0xc; // Gaussian fit
    protected static int  FFT_POLYNORM_QUADRTIC_FIT = 0xd; // Parabolic fit
    protected static int  FFT_POLYNORM_CUBIC_FIT = 0xe; // Cubic fit
    protected static int  FFT_POLYNORM_QUARTIC_FIT = 0xf; // Quartic fit
    
    public static int  PS_SOLID = 0,
                          PS_DASH = 1,
                          PS_DOT = 2,
                          PS_DASH_DOT = 3;

    public static int  mode_polyline = 0,
                        mode_barline = 1,
                        mode_histogram = 2,
                        mode_dots = 3,
                        mode_histogram_rastoring = 4,
                        mode_rectangle = 5,
                        mode_circle = 6,
                        mode_textbox = 7,
                        mode_polyline_dots = 8,
                        mode_barline_dots = 9,
                        mode_histogram_dots = 10,
                        mode_histogram_rastoring_dots = 11,
                        mode_barline_histo = 12,
                        mode_barline_histo_dots = 13,
    					mode_polyline_cross = 14,
    					mode_annotation = 15,
    					mode_status = 16,
                        mode_barline_ganttplot = 17,
                        mode_barline_bit = 18;
                        
    protected static double log_check(double x)
    {
      if ( x < 1.0e-18 ) x = 1.0e-19; // it was -14 and -15 2007-10 hwu
      return x;
    }

	protected static BasicStroke createStroke(float penWidth, int penStyle)
	{ BasicStroke stroke;
		
	  if ( penStyle == PS_SOLID )
	  {
  		if ( penWidth <= 1 ) stroke = new BasicStroke(penWidth);
	  	else stroke = new BasicStroke(penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER);
	  }
	  else if ( penStyle == AcopConst.PS_DASH )
		  stroke = new BasicStroke(penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,penWidth,new float[]{6.f,2.f},6f);
	  else if ( penStyle == AcopConst.PS_DOT )
		  stroke = new BasicStroke(penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,penWidth,new float[]{2.f,2.f},2f);
	  else
		  stroke = new BasicStroke(penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,penWidth,new float[]{2.f,2.f,6.f,2.f},2f);

	  return stroke;
	}

}
