package de.desy.acop.chart;
import java.awt.Rectangle;

public class AcopFrame
{
	protected java.awt.Color frameForeColor;
	protected java.awt.Font frameFont;
  protected boolean leftTimeLabel;   // it is valid only for x
	protected int histogramPosition;
  protected Rectangle histRect;    // pixel width and height
	protected boolean drawFlag;
	
	protected int ZoomExtent;
  protected Rectangle zoomIcon;
	
	protected int xleft, xright, dxwidth, absxleft;

  public AcopFrame()
	{
      histRect = new Rectangle();
      zoomIcon = new Rectangle();
      ZoomExtent = 36;
		//{{INIT_CONTROLS
		//}}
	}
	
	//{{DECLARE_CONTROLS
  protected void getOxleftright(AcopHisto pHisto, AcopScale pScale)
  { int Rest, Wpixel, Offset;
    double xtemp;
      
    if ( pHisto.dismode == AcopConst.mode_histogram_rastoring )
    {
      dxwidth = Math.min( histRect.width, (int)(pScale.max-pScale.min) );
      if (dxwidth < 2) dxwidth = pHisto.npoints > 2 ? pHisto.npoints - 1 : 1;
      if ( histRect.width >= dxwidth )
      {
        Wpixel = histRect.width / dxwidth;        // space between two indices
    	  Offset = histRect.width % Wpixel;		    // fractions to get rid of
    	  Rest = ((histRect.width-Offset) % dxwidth);// rest to compensate histogram
    	  if ( histogramPosition == 0 )	    		// left adjusted
        {
      		xleft = 0;
	   	    xright = histRect.width - Rest - Offset;
        }
        else if ( histogramPosition == 2 )  // right adjusted
        {
      		xleft = Rest + Offset;
		      xright = histRect.width;
		    }
  		  else									// centered
	      {
          xleft = Rest/2;
          xright = histRect.width - (Rest - Rest/2) - Offset;
    	  }
    	}
    }
    else
    {
      xleft  = 0;
    	xright = histRect.width;
    }
    dxwidth = xright - xleft;
    absxleft = xleft + histRect.x;
  }
	//}}
}

