/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.chart.customizer;

import java.awt.event.ItemEvent;
import java.lang.reflect.Method;

import javax.swing.JRadioButton;

import de.desy.acop.chart.Acop;

public class AcopJRadioButton extends JRadioButton
{
  private static final long serialVersionUID = -2954560870321212546L;
  Acop acopBean;
  String proper, fireProper;
  public AcopJRadioButton()
  {
    super();
  }
  public void setAcopBean(Acop Bean)
  {
    acopBean = Bean;
    try
    {
      Method m = acopBean.getClass().getMethod("is" + proper);
      this.setSelected((Boolean) m.invoke(acopBean));
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }
  public AcopJRadioButton(String text, String property, String fireProperty)
  {
    super();
    proper = property;
    fireProper = fireProperty;
    setText(text);
    setSelected(false);
    this.addItemListener(new java.awt.event.ItemListener()
    {
      public void itemStateChanged(ItemEvent e)
      {
        if (acopBean != null)
        {
          try
          {
            Method m = acopBean.getClass().getMethod("set" + proper, boolean.class);
            boolean soll = e.getStateChange() == ItemEvent.SELECTED ? true : false;
            m.invoke(acopBean, soll);
//            System.out.println("set property: " + fireProper + "   value: " + soll); // TODO
                                                                                      // Auto-generated
                                                                                      // Event
                                                                                      // stub
                                                                                      // itemStateChanged()
            // firePropertyChange(null, null, null);
            firePropertyChange(fireProper, !soll, soll);
          }
          catch (Exception ex)
          {
            ex.printStackTrace();
          }
        }
      }
    });
  }
}
