/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.displayers;
 
import java.beans.IntrospectionException;

import com.cosylab.gui.components.util.IconHelper;
import com.cosylab.util.BeanInfoSupport;

import de.desy.acop.displayers.selector.ChartSelectorPropertyEditor;
  
/** 
 * <code>BeanInfo</code> for <code>AcopChart</code>.
 * 
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 * @see AcopChart
 */ 
public class AcopChartBeanInfo extends BeanInfoSupport {
	  
	/**  
	 * Creates new instance of AcopDisplayerBeanInfo.
	 * @throws IntrospectionException 
	 */
	public AcopChartBeanInfo() throws IntrospectionException {
		super(); 
		setBeanDescriptor(AcopChartCustomizer.class);
		loadDefaultPropertyDescriptors();     
		overridePropertyDescriptor("displayerParameters", ChartSelectorPropertyEditor.class, "getDisplayerParameters", "setDisplayerParameters");
//		loadPropertyDescriptor("displayerParameters", ChartSelectorPropertyEditor.class);
		removePropertyDescriptor("connectionParameters");           
	}	
	
	/*
	 * (non-Javadoc)
	 * @see java.beans.SimpleBeanInfo#getIcon(int)
	 */
	@Override
    public java.awt.Image getIcon(int iconKind) {
    	return IconHelper.createImage("icons/chart/ChartChubby16.gif");
    }
	
	
}

