/**
 * File: EMetaFecInfo.java
 * Date: Jul 29, 2010
 */
package de.desy.acop.displayers.tarantula;

/**
 * Meta information for the {@link ConnectionInfo} class. 
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: EConnectionInfoMeta.java 40186 2010-11-03 14:12:06Z walla $
 */
enum EConnectionInfoMeta { 
    RESPONSIBLE("Responsible"), 
    LOCATION("Location"), 
    FEC_NAME("FEC name"),
    EQM_NAME("Equipment name"),
    OS("Operating system"), 
    HOST_NAME("Host name"),
    IP_ADDRESS("IP address"),
    IP_ADDRESS_RAW("IP address (raw)"),
    PORT_OFFSET("Port offset"),
    VERSION("TINE version"),
    HARDWARE("Hardware"),
    DESCRIPTION("Description"); 

    // --- INSTANCE FIELDS -------------------------------------------------

    private final String description;

    // --- CONSTRUCTOR -----------------------------------------------------

    EConnectionInfoMeta(final String description) { 
        this.description = description; 
    }

    // --- INSTANCE METHODS ------------------------------------------------

    String getDescription() { return this.description; }
}
/* end of file */