/**
 * File: ITarantulaUpdateListener.java
 * Date: Jul 29, 2010
 */
package de.desy.acop.displayers.tarantula;

import java.util.EventListener;

/**
 * Tarantula update or refresh listener. This is implemented as an argument for 
 * the methods of {@link TarantulaPanel#addTarantulaUpdateListener(ITarantulaUpdateListener)} 
 * or {@link TarantulaPanel#removeTarantulaUpdateListener(ITarantulaUpdateListener)}.
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: ITarantulaUpdateListener.java 40186 2010-11-03 14:12:06Z walla $
 */
public interface ITarantulaUpdateListener extends EventListener {
	
	/**
	 * After a node is refreshed in its hierarchical structure this method can
	 * be called to update its content in Swing. 
	 * 
	 * @param event Node event. Includes the updated node.
	 */
	public abstract void refreshTarantula(final TarantulaEvent event);
}
/* end of file */