package de.desy.acop.print.logbook;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.net.UnknownHostException;

public class Mail {

	private static final String HOST_SMTP = "smtp.desy.de";//Postausgangsserver
	private static final int PORT_SMTP = 25;
	//	private final String HOST_IMAP = "ximap.desy.de";//Server
	//	private final int PORT_IMAP = 993;
	private static final String DEFAULT_SENDER = "mca-automatic-notification@desy.de";


	private String getSender(final String sender) {
		if (sender == null) return DEFAULT_SENDER;
		else return sender;
	}

	private String getAuthor(final String entryAuthor) {
		if (entryAuthor != null && entryAuthor.length() >= 1) {
			return "Autor, " + entryAuthor + "\r\n" + "\r\n";
		} else {
			return "";
		}
	}

	private String getBody(final String entryAuthor, final String body) {
		String s = "No text was submitted";
		final String author = getAuthor(entryAuthor);
		if (body != null && body.length() >= 1) {
			s = body;
		}
		s = author + s + "\r\n" + "\r\n" + "." + "\r\n" + "QUIT\r\n";
		return s;
	}

	private String getSubject(final String subject) {
		String s = "Mail from Tine Studio, no subject";
		if (subject != null && subject.length() >= 1) {
			s = subject;
		}
		s = "Subject:" + s + "\r\n";
		return s;
	}

	private void sendLine(final BufferedWriter bw, final String line) throws IOException {
		bw.write(line);
		bw.flush();
	}

	public void sendMail(final String subj, final String bd, final String entryAuthor, final String[] to, final String from) throws IOException, UnknownHostException, IllegalArgumentException {
		final String[] rec = to;
		final String sender = getSender(from);
		final String body = getBody(entryAuthor,bd);
		final String subject = getSubject(subj);
		if (rec == null) {
			throw new IllegalArgumentException("Mail could not be sent. Recipient is unknown.");
		}
		for (int i = 0; i < rec.length; i++) {
			try (final Socket socket = new Socket(HOST_SMTP,PORT_SMTP)) {
    			try (BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()))) {
        			//Kontakt mit dem Server aufnehmen
        			sendLine(bw,"Helo " + HOST_SMTP + "\r\n");
        			//Absender hinschicken
        			sendLine(bw,"MAIL FROM:<" + sender + ">\r\n");
        			//Empfnger hinschicken
        			sendLine(bw,"RCPT TO:" + rec[i] + "\r\n");
        			//dem Server sagen: jetzt kommen die Daten
        			sendLine(bw,"DATA\r\n");
        			//Betreff und Text senden
        			sendLine(bw,subject + body);
    			}
			} 
		}
	}
}
