/*
 * Created on Jun 22, 2004 To change the template for this generated file go to Window&gt;Preferences&gt;Java&gt;Code
 * Generation&gt;Code and Comments
 */
package de.desy.acop.print.logbook;

import java.awt.Graphics;
import java.awt.image.ImageObserver;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.util.Vector;

/**
 * @author K. Hinsch -mst1-
 * @task some common tasks likefilePrintHelper and PageSetUp
 */
class MstPrintAll implements Printable {

    PrinterJob pjob;
    PageFormat pageformat;
    /**
     * @uml.property name="fph"
     * @uml.associationEnd multiplicity="(0 1)" inverse="this$0:de.desy.mst.io.MstPrintAll$FilePrintHelper"
     */
    FilePrintHelper fph;
    ImageObserver imo;
    /**
     * @uml.property name="rESMUL" changeability="frozen"
     */
    //	---Konstanten--------------------------------------
    static final int RESMUL = 4;

    //	interne Klassen
    public static class FilePrintHelper {

        //---Membervariablen----------------------------------
        Vector<Entry> pageinfo;

        //---Konstruktor--------------------------------------
        public FilePrintHelper() {
            this.pageinfo = new Vector<>();
        }

        //---Seitendefinition und -abfrage--------------------
        public void createPage(final int page) {
            for (int i = this.pageinfo.size(); i <= page; ++i) {
                this.pageinfo.addElement(new Entry());
            }
        }

        public boolean knownPage(final int page) {
            return page < this.pageinfo.size();
        }

        //---Verwaltung der Offsets---------------------------
        public long getFileOffset(final int page) {
            final Entry entry = this.pageinfo.elementAt(page);
            return entry.fileoffset;
        }

        public void setFileOffset(final int page, final long fileoffset) {
            final Entry entry = this.pageinfo.elementAt(page);
            entry.fileoffset = fileoffset;
        }

        //---Lokale Klasse Entry------------------------------
        static class Entry {

            public long fileoffset;

            public Entry() {
                this.fileoffset = -1;
            }
        }
    }

    //	---�ffentliche Methoden----------------------------
    public boolean setupPageFormat() {
        final PageFormat defaultPF = this.pjob.defaultPage();
        this.pjob.setPrintable(this,this.pjob.pageDialog(defaultPF));
        return (this.pageformat != defaultPF);
    }

    public boolean setupJobOptions() {
        return this.pjob.printDialog();
    }

    //Implementierung von Printable
    public int print(final Graphics g, final PageFormat pf, final int page) throws PrinterException {
        return 0;
    }
}
