package de.desy.acop.transport;
import java.util.Vector;
import de.desy.acop.transport.simulator.AcopTransportSimulator;
import de.desy.acop.transport.tine.AcopTransportTine;
/**
 * @version 	1.0
 * @author
 */
public class AcopTransportFactory
{
  private static AcopTransportFactory instance;
  protected String defaultProtocol;
  protected Vector atps = new Vector();
  protected String[] acopProtocolList;
  public static AcopTransportFactory getInstance() 
  {
    if (instance==null) instance=new AcopTransportFactory();
    return instance;
  }
  int addProtocol(AcopTransportPlug atp)
  {
    for (int i=0; i<atps.size(); i++)
    {
      if ((AcopTransportPlug)atps.elementAt(i) == atp) return 0;
    }
    atps.addElement(atp);
    System.out.println("add protocol " + atp.getPlugName());
    if (defaultProtocol == null) setDefaultProtocol(atp.getPlugName());
    return 0;
  }
  AcopTransportFactory()
  {
    addProtocol(new AcopTransportTine());
    addProtocol(new AcopTransportSimulator());
  }
  int setDefaultProtocol(String protocolName)
  {
    for (int i=0; i<atps.size(); i++)
    {
      if (((AcopTransportPlug)atps.elementAt(i)).getPlugName() == protocolName)
      {
        defaultProtocol = new String(protocolName);
        System.out.println("Use protocol " + protocolName + " as default");
        return 0;
      }
    }
    return -1;
  }
  public String getDefaultProtocol()
  {
    return defaultProtocol;
  }
  public String[] getProtocolList()
  {
    AcopTransportPlug atp;
    if (acopProtocolList == null)
    {
      acopProtocolList = new String[atps.size()];
      for (int i=0; i<atps.size(); i++)
      {
        atp = (AcopTransportPlug)atps.elementAt(i);
        acopProtocolList[i] = atp.getPlugName();
      }
    }
    return acopProtocolList;
  }
  public AcopTransportPlug getProtocol(String protocolName)
  {
    AcopTransportPlug atp;
    String protocol = protocolName;
    if (protocol == null || protocol.length() == 0) protocol = getDefaultProtocol();
    for (int i=0; i<atps.size(); i++)
    {
      atp = (AcopTransportPlug)atps.elementAt(i);
      if (atp.getPlugName().compareTo(protocol) == 0) return atp;
    }
    return null;
  }
  protected void halt()
  {
    AcopTransportPlug atp;
    AcopTransportRequest atr = new AcopTransportRequest();
    for (int i=0; i<atps.size(); i++)
    {
      atp = (AcopTransportPlug)atps.elementAt(i);
      atr.accessMethod = AcopTransportAccessMethods.SHUTDOWN;
      atp.handleRequest(atr);
    }
  }
}
