package de.desy.acop.transport;
import java.util.Date;
/**
 * @version 	1.0
 * @author
 */
public class AcopTransportRequest
{
  private String emptyString = new String("");
  public String deviceContext = emptyString;
  public String deviceGroup = emptyString;
  public String deviceName = emptyString;
  public String deviceProperty = emptyString;
  private Object data;
  private Object dataEx;
  private int arraySize;
  private int arraySizeEx;
  private int dataSize;
  private int dataSizeEx;
  private Date dataTimeStamp;
  protected boolean pending;
  public boolean isUnboundToData;
  public int statusCode;
  public String status = emptyString;
  public String accessMode = emptyString;
  public String accessRate = emptyString;
  public String accessProtocol = emptyString;
  public int accessMethod;
  private int linkHandle;
  private int linkIdentifier;
  public AcopTransportCallback atc;
  public int getLinkHandle() { return linkHandle; }
  public int getLinkIdentifier() { return linkIdentifier; }
  public void setLinkIdentifier(int id) { linkIdentifier = id; }
  public void setLinkHandle(int id) { linkHandle = id; }
  public boolean compareTo(AcopTransportRequest atr)
  {
    if (atr.accessMode.compareTo(accessMode) == 0 &&
        atr.accessRate.compareTo(accessRate) == 0 &&
        atr.accessProtocol.compareTo(accessProtocol) == 0 &&
        atr.arraySize == arraySize &&
        atr.arraySizeEx == arraySizeEx &&
        atr.atc == atc &&
        atr.data == data &&
        atr.dataEx == dataEx &&
        atr.deviceContext.compareTo(deviceContext) == 0 &&
        atr.deviceGroup.compareTo(deviceGroup) == 0 &&
        atr.deviceName.compareTo(deviceName) == 0 &&
        atr.deviceProperty.compareTo(deviceProperty) == 0) return true;

    return false;         
  }
  public AcopTransportRequest cloneTransportRequest()
  {
    AcopTransportRequest atr = new AcopTransportRequest();
    atr.accessMethod = accessMethod;
    atr.accessMode = new String(accessMode);
    atr.accessRate = new String(accessRate);
    atr.accessProtocol = new String(accessProtocol);
    atr.isUnboundToData = isUnboundToData;
    atr.arraySize = arraySize;
    atr.arraySizeEx = arraySizeEx;
    atr.atc = atc;
    atr.data = data;
    atr.dataEx = dataEx;
    atr.deviceContext = new String(deviceContext);
    atr.deviceGroup = new String(deviceGroup);
    atr.deviceName = new String(deviceName);
    atr.deviceProperty = new String(deviceProperty);
    atr.linkHandle = linkHandle;
    atr.linkIdentifier = linkIdentifier;
    return atr;    
  }
  public int getArraySize() { return arraySize; }
  public void setArraySize(int arraySize) { this.arraySize = arraySize; }
  public int getArraySizeEx() { return arraySizeEx; }
  public void setArraySizeEx(int arraySizeEx) { this.arraySizeEx = arraySizeEx; }
  public Object getData() { return data; }
  public void setData(Object data) { this.data = data; }
  public Object getDataEx() { return dataEx; }
  public void setDataEx(Object dataEx) { this.dataEx = dataEx; }
  public int getDataSize() { return dataSize; }
  public void setDataSize(int dataSize) { this.dataSize = dataSize; }
  public int getDataSizeEx() { return dataSizeEx; }
  public void setDataSizeEx(int dataSizeEx) { this.dataSizeEx = dataSizeEx; }
  public Date getDataTimeStamp() { return dataTimeStamp; }
  public void setDataTimeStamp(Date dataTimeStamp) { this.dataTimeStamp = dataTimeStamp; }
  public String getStatus() { return status; }
  public void setStatus(String status) { this.status = status; }
  public int getStatusCode() { return statusCode; }
  public void setStatusCode(int statusCode) { this.statusCode = statusCode; }
}
