/**
 * 
 */
package de.desy.acop.video;

import java.awt.Color;

import de.desy.tine.types.IMAGE;

/**
 * This class provides the definitions of numerical constants and colors used in 
 * </code>AcopVideo</code> and </code>SideProfileDisplayer</code> to draw analysis 
 * elements.
 * 
 * @author Tilen Kusterle, Cosylab
 *
 */
public class Definitions {
	 
//	public static final int MAX_WIDTH = 768;
//	public static final int MAX_HEIGHT = 768;
	
	public static final int MAX_WIDTH = 2000;
	public static final int MAX_HEIGHT = 2000;
	public static final int IMAGE_SIZE = IMAGE.HEADER_SIZE + 8; //188 + 8 = 196
	//MAXSIZE = 6291456;
//	public static final int MAX_SIZE = 768 * 574 + VideoHeaderV2.HDRSIZE;
	//A_IMAGE_MAX_SIZE = 6304068 = MAX_SIZE + sideviewX(768 doubles), sideviewY(768 doubles) + 10* intFields (8*ROI+width+height) + 23*doubleFields (mean, std, etc) + calculateThreshold + performFit, image header
//	public static final int A_IMAGE_MAX_SIZE =  MAX_SIZE + 8*MAX_WIDTH + 8*MAX_HEIGHT + 10*4 + 22*8 + 2 + IMAGE.HEADER_SIZE;
	// 10*intFields (8*ROI+width+height) + 22*doubleFields (mean, std, etc) + calculateThreshold + performFit, image header
	public static final int A_IMAGE_MAX_SIZE = IMAGE_SIZE + 10*4 + 22*8 + 2 + 8*MAX_HEIGHT + 8*MAX_WIDTH;

	
	private static final Color BACKGROUND_COLOR = Color.DARK_GRAY;
	private static final Color CANVAS_COLOR = Color.BLACK;
	private static final Color NEGATIVE_CANVAS_COLOR = Color.WHITE;
	private static final Color ROI_COLOR = Color.BLUE;
	private static final Color ROI_SELECTING_COLOR = Color.YELLOW;
	private static final Color NEGATIVE_ROI_SELECTING_COLOR = Color.GREEN;
	private static final Color DATA_COLOR = Color.WHITE;
	private static final Color NEGATIVE_DATA_COLOR = Color.BLACK;
	private static final Color FIT_COLOR = Color.GREEN;
	private static final Color STATISTICS_COLOR = Color.RED;
	private static final Color THRESHOLD_ROI_COLOR = Color.ORANGE;
	
	private static final boolean negatives = true;
	
	public static Color getBackgroundColor() {
		return BACKGROUND_COLOR;
	}
	
	public static Color getCanvasColor() {
		if (negatives) return NEGATIVE_CANVAS_COLOR;
		return CANVAS_COLOR;
	}
	
	/**
	 * Color for marking the region of interest.
	 * 
	 * @return
	 */
	public static Color getRoiColor() {
		return ROI_COLOR;
	}
	
	/**
	 * Color for threshold region of interest.
	 * 
	 * @return
	 */
	public static Color getThresholdRoiColor() {
		return THRESHOLD_ROI_COLOR;
	}
	
	public static Color getRoiSelectingColor() {
		if (negatives) return NEGATIVE_ROI_SELECTING_COLOR;
		return ROI_SELECTING_COLOR;
	}
	
	public static Color getDataColor() {
		if (negatives) return NEGATIVE_DATA_COLOR;
		return DATA_COLOR;
	}
	
	/**
	 * Color for drawing fitting results.
	 * 
	 * @return
	 */
	public static Color getFitColor() {
		return FIT_COLOR;
	}
	
	/**
	 * Color for drawing statistical results.
	 * @return
	 */
	public static Color getStatisticsColor() {
		return STATISTICS_COLOR;
	}
}
