package de.desy.acop.video.analysis;

/**
 * 
 * <code>MathException</code> is an execption thrown when
 * a calculation was being made and it failed due to improper data, such
 * as for instance solving linear systems of singular matrix etc.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public class MathException extends Exception {

	private static final long serialVersionUID = 1L;
	
	/**
	 * Constructs a new MathException.
	 *
	 */
	public MathException() {
		super();
	}
	/**
	 * Constructs a new MathException with the explanation of the
	 * exception provided as parameter.
	 * 
	 * @param message short explanation of the exception
	 */
	public MathException(String message) {
		super(message);
	}
	
	/**
	 * Constructs a new MathException with the explanation of the
	 * exception and its couse provided as parameters.
	 * 
	 * @param message short explanation of the exception
	 * @param cause the cause of the exception
	 */
	public MathException(String message, Throwable cause) {
		super(message, cause);
	}
}
