/**
 *
 */
package de.desy.acop.video.analysis.decoders;

import de.desy.acop.video.analysis.ColorDecoder;

/**
 * </code>IdentitiyColorDecoder</code> transforms the value to RGB integer.
 *
 * @author Tilen Kusterle, Cosylab
 *
 */
public class IdentityColorDecoder implements ColorDecoder {

	/* (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int)
	 */
	@Override
	@Deprecated
	public double transform(int code) {
		return code;
	}

	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int[])
	 */
	@Override
	public double[] transform(int[] data) {
		int length = data.length;
		double[] ret = new double[length];
		for (int i = 0; i < length; i++) {
			ret[i] = data[i];
		}
		return ret;
	}

	@Override
	public double[] transformBGR(int[] data) {
	    int length = data.length;
        double[] ret = new double[length];
        for (int i = 0; i < length; i++) {
            ret[i] = ((data[i] >> 16) & 0xFF) | (data[i] & 0xFF00) | ((data[i] & 0xFF) << 16);
        }
        return ret;
	}
}
