package de.desy.acop.video.displayer;

/**
 * Overlay information enumeration
 * 
 * @author mdavid
 */
public enum OverlayState {
	
	/**
	 * overlay information always enabled.
	 */
	ON("On"),

	/**
	 * overlay information always disabled.
	 */
	OFF("Off"),

	/**
	 * overlay information appears when moving over video frame.
	 */
	AUTO("Auto");

	private final String descr;

	OverlayState(String description) {
		this.descr = description;
	}

	public String getDescription() {
		return descr;
	}
}