/*
 * Created on Mar 1, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Console logging configuration.
 * @see CfgLogging
 * @author jwlg
 */
@XmlRootElement
public class CfgLogConsole {
    
    private boolean enabled = true;
    private CfgLogLevel threshold = CfgLogLevel.ALL;
    
    /**
     * Returns true if console logging is enabled.
     */
    @XmlElement
    public boolean isEnabled() {
        return enabled;
    }
    
    /**
     * Enables or disables console logging.
     * @param enabled True if enabled.
     */
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }
    
    /**
     * Returns the Threshold.
     */
    @XmlElement
    public CfgLogLevel getThreshold() {
        return threshold;
    }
    
    /**
     * Sets the threshold.
     * @param threshold New threshold.
     */
    public void setThreshold(CfgLogLevel threshold) {
        this.threshold = threshold;
    }

}
