/*
 * Created on Jan 17, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Specifcation of an operation.
 * An operation corresponds to a TINE property which has input
 * and output data. IN opposite to a property, an operation may use
 * user-defined data types for input or output.
 * 
 * @author jwlg
 */
@XmlRootElement
public class CfgOperation {
    
    private String name = "";
    private String description = "";
    private CfgOperationDataType inputData = new CfgOperationDataType();
    private CfgOperationDataType outputData = new CfgOperationDataType();
    
    /**
     * Returns the name of an operation.
     */
    @XmlElement
    public String getName() {
    
        return name;
    }
    
    /**
     * Sets the name of an operation.
     * @param name New name.
     */
    public void setName(String name) {
    
        this.name = name;
    }
    
    /**
     * Returns the description.
     */
    @XmlElement
    public String getDescription() {
    
        return description;
    }
    
    /** Sets the description. 
     * @param description New description.
     **/
    public void setDescription(String description) {
    
        this.description = description;
    }
    
    /**
     * Returns the input data section.
     */
    @XmlElement
    public CfgOperationDataType getInputData() {
    
        return inputData;
    }

    /**
     * Sets the input data section.
     * Only for JAXB.
     * @param inputData New section.
     */
    public void setInputData(CfgOperationDataType inputData) {
    
        this.inputData = inputData;
    }

    /**
     * Returns the output data section.
     */
    @XmlElement
    public CfgOperationDataType getOutputData() {
    
        return outputData;
    }

    /**
     * Sets the output data sectiom.
     * Only for JAXB.
     * @param outputData New section.
     */
    public void setOutputData(CfgOperationDataType outputData) {
    
        this.outputData = outputData;
    }

}
