/*
 * Created on Jan 16, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Display information for a property.
 * The display information proposes how a property 
 * should be displayed by ACOP. One data set 
 * concerns either the x or the y axis. 
 * @author jwlg
 */
@XmlRootElement
public class CfgPropertyDataInfo {
    
    
    private double minimumValue = 0.0;
    private double maximumValue = 0.0;
    private CfgPropertyGraphType graphType = CfgPropertyGraphType.LINEAR;
    private String units = "";
    
    /**
     * Returns the graph type.
     */
    @XmlElement
    public CfgPropertyGraphType getGraphType() {
    
        return graphType;
    }
    
    /**
     * Sets the graph type.
     * 
     * @param graphType New graph type.
     * @see CfgPropertyGraphType
     */
    public void setGraphType(CfgPropertyGraphType graphType) {
    
        this.graphType = graphType;
    }
    
    /**
     * Returns the maximum value.
     */
    @XmlElement
    public double getMaximumValue() {
    
        return maximumValue;
    }
    
    /**
     * Sets the maximum value.
     * @param maximumValue New value.
     */
    public void setMaximumValue(double maximumValue) {
    
        this.maximumValue = maximumValue;
    }
    
    /**
     * Returns the minimum value.
     */
    @XmlElement
    public double getMinimumValue() {
    
        return minimumValue;
    }

    /**
     * Sets the minimum value.
     * @param minimumValue New value.
     */
    public void setMinimumValue(double minimumValue) {
    
        this.minimumValue = minimumValue;
    }
    
    /**
     * Returns the units.
     */
    @XmlElement
    public String getUnits() {
    
        return units;
    }
    
    /**
     * Sets the units.
     * @param units New value.
     */
    public void setUnits(String units) {
    
        this.units = units;
    }

}
