/*
 * Created on Jan 16, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;


import de.desy.tine.definitions.TGraphType;

/**
 * An enumeration of graph types.
 * 
 * Graph types are not eplained in the TINE docs,
 * but used by TINE tools like ACOP and instant client.
 * They specify how the data should be displayed.
 * 
 * @author jwlg
 */
public enum CfgPropertyGraphType {
    
    /**
     * Linear scale.
     */
    LINEAR("Linear", TGraphType.GT_LIN),
    
    /**
     * Logarithmic scale.
     */
    LOGARITHMIC("Logarithmisch", TGraphType.GT_LOG),
    
    /**
     * Bit array.
     */
    BITARRAY("Bit-Array", TGraphType.GT_BIT),
    
    /**
     * Raw text.
     */
    TEXT("Text", TGraphType.GT_TEXT);
    
    private int key = 0;
    private String name = "";

    private CfgPropertyGraphType(String name, int value) {
        this.name = name;
        this.key = value;
    }
    
    /**
     * Returns the name.
     */
    public String getName() {
        return name;
    }

    /**
     * Returns the key.
     */
    public int getKey() {
        return key;
    }

    /**
     * Returns the name.
     */
    public String toString() {
        return getName();
    }
    
}
