/*
 * Created on Jan 16, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

import java.util.HashMap;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Device Server configuration.
 * This configuration section contains device server 
 * parameters which are needed at runtime.
 */
@XmlRootElement
public class CfgServer {
    
    private int updateInterval = 1000;
    private String applicationName = "";
    private HashMap<String, String> environment = new HashMap<String, String>();
    
    /**
     * Returns the application name.
     */
    @XmlElement
    public String getApplicationName() {
        return applicationName;
    }
    
    /**
     * Sets the application name.
     * @param applicationName New application name.
     */
    public void setApplicationName(String applicationName) {
        this.applicationName = applicationName;
    }
    
    /**
     * Returns the environment variables.
     */
    @XmlElementWrapper(name="environment")
    public HashMap<String, String> getEnvironment() {
        return environment;
    }
    
    /**
     * Sets the environment variables.
     * Not intended for general use. Required by JAXB.
     * @param environment New environment variables.
     */
    public void setEnvironment(HashMap<String, String> environment) {
        this.environment = environment;
    }
    
    /**
     * Returns the update interval.
     */
    @XmlElement
    public int getUpdateInterval() {
        return updateInterval;
    }
    
    /**
     * Sets the update interval.
     * @param updateIntervalMs New upadte interval.
     */
    public void setUpdateInterval(int updateIntervalMs) {
        this.updateInterval = updateIntervalMs;
    }
}
