/*
 * Created on Sep 21, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;

/**
 * Thrown by a device to indicate that a concurrent operation is running.
 * This exception means that a method cannot be executed or cannot 
 * return a correct value because another operation is going on.
 * 
 * @author jwlg
 */
public class DeviceBusyException extends DeviceException {

    private static final long serialVersionUID = -2429710275054961459L;

    /**
     * Default constructor.
     */
    public DeviceBusyException() {
        super(ErrorSpecs.DEVICE_BUSY_EXCEPTION);
    }

    /**
     * Constructor with a specific message.
     * @param message A message which overrides the default message.
     */
    public DeviceBusyException(String message) {
        super(ErrorSpecs.DEVICE_BUSY_EXCEPTION,message);
    }

}
