/*
 * Created on Sep 21, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;

/**
 * Thrown to indicate that a device is not in an expected state.
 * This exception means that a method cannot be executed or cannot 
 * return a correct value because the device is inaccessible
 * or inoperable.
 * 
 * @author jwlg
 */
public class DeviceException extends PredefinedException {
    
    private static final long serialVersionUID = 8415271278332720993L;

    /**
     * Default constructor.
     */
    public DeviceException() {
        super(ErrorSpecs.IO_EXCEPTION);
    }
    
    /**
     * Constructor with a specific message.
     * @param message A message which overrides the default message.
     */
    public DeviceException(String message) {
        super(ErrorSpecs.IO_EXCEPTION, message);
    }
    
    /**
     * Called only called by derived classes.
     * @param errorSpecs
     * @param message
     */
    DeviceException(ErrorSpecs errorSpecs, String message) {
        super(errorSpecs, message);
    }
    
    /**
     * Called only by derived classes.
     * @param errorSpecs
     */
    DeviceException(ErrorSpecs errorSpecs) {
        super(errorSpecs);
    }
    
}
