/*
 * Created on Sep 21, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;

/**
 * Thrown to indicate that a device is not in an orderly state.
 * This exception means that a method cannot be executed or cannot 
 * return a correct value because the device is not ready for operation
 * or is in an undefined state.
 * 
 * @author jwlg
 */
public class DeviceNotReadyException extends DeviceException {

    private static final long serialVersionUID = -6895672912266739558L;

    /**
     * Default constructor.
     */
    public DeviceNotReadyException() {
        super(ErrorSpecs.DEVICE_NOT_READY_EXCEPTION);
    }

    /**
     * Constructor with a specific message.
     * @param message A message which overrides the default message.
     */
    public DeviceNotReadyException(String message) {
        super(ErrorSpecs.DEVICE_NOT_READY_EXCEPTION,message);
    }

}
