/*
 * Created on Sep 20, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;


/**
 * Base class for all device server exception.
 * All exceptions which can be thrown by devices must be 
 * derived from this class. 
 * @author jwlg
 */
public abstract class DeviceServerException extends Exception {
    
    /**
     * Default constructor.
     */
   public DeviceServerException() {
        super();
    }

    /**
     * Constructor with a specific message.
     * @param message A message which overrides the default message.
     */
    public DeviceServerException(String message) {
        super(message);
    }

    /**
     * Returns the error key.
     */
    public abstract int getErrorKey();
    
}
