/*
 * Created on Apr 3, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.server;


/**
 * The base class for operation handlers.
 * 
 * An operation is a property which has input and output data.
 * Operation handlers are generated by the device server wizard.
 * The class AOperationHandler serves as a base class for all 
 * generated operation handlers. It inherits functionality from 
 * ABasicPropertyHandler.
 * 
 * @author jwlg
 */
public abstract class AOperationHandler<D extends IBasicDevice> extends ABasicPropertyHandler<D> {

   
    /**
     * Constructor.
     * 
     * @param operationName The name of the operation.
     * @param deviceGroup The device group.
     */
    public AOperationHandler(String operationName, DeviceGroup<D> deviceGroup) {
        super(operationName, deviceGroup);
        /*
        this.operationConfig = deviceGroup.getOperationConfiguration(operationName);
        if (this.operationConfig == null) {
            log.error("Operation configuration not found for " + operationName);
        }
        */
    }
 
    /**
     * Returns the name of the operation.
     */
    public String getOperationName() {
        return getPropertyName();
    }

}
