package de.desy.mst.auxiliary.devl.deviceserverlib.server;

import java.util.Set;

import de.desy.mst.auxiliary.devl.deviceserverlib.alarms.Alarm;

/**
 * @version 1.0
 * @created 18-Sep-2007 10:47:00
 */
public interface IBasicModuleFactory<T extends IBasicDevice> {
    

    /**
     * Creates the common data for a device group.
     * This method has to be implemented by derived classes.
     */
    public ACommonData<T> createCommonData();
    
    /**
     * Creates an alarm set.
     * This method has to be implemented by derived classes.
     */
    public Set<Alarm> createAlarmSet();

    /**
     * Creates the property set.
     * This method has to be implemented by derived classes.
     * @param deviceGroup The device group.
     */
    public PropertySet<T> createPropertySet(DeviceGroup<T> deviceGroup);


}