/*
 * Created on Jun 7, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.tools.selector;

import java.util.List;
import java.util.Set;

/**
 * An abstract base class for all selectors.
 * Implements the collection methods if ISelectorSet.
 * 
 * @author jwlg
 */
public abstract class ASelector<T> implements ISelector<T> {
    
    public List<T> select(List<T> source, List<T> target) {
        for (T entry : source) {
            if (isSelected(entry)) {
                target.add(entry);
            }
        }
        return target;
    }
    
    public Set<T> select(Set<T> source, Set<T> target) {
        for (T entry : source) {
            if (isSelected(entry)) {
                target.add(entry);
            }
        }
        return target;
    }
    
    public List<T> select(T[] source, List<T> target) {
        for (T entry : source) {
            if (isSelected(entry)) {
                target.add(entry);
            }
        }
        return target;
    }

}
