/*
 * Created on Jun 7, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.tools.selector;

import java.util.LinkedList;

/**
 * A base class for all selector sets.
 * 
 * This class implements a set of selectors and the possibility to
 * add selectors. 
 *
 * @author jwlg
 */
public abstract class ASelectorSet<T> extends ASelector<T> implements ISelectorSet<T> {

    LinkedList<ISelector<T>> aSelectors = new LinkedList<ISelector<T>>();
    
    public ASelectorSet() {
        super();
    }

    /**
     * Adds a selector.
     */
    public final void addSelector(ISelector<T> newSelector) {
        aSelectors.add(newSelector);
    }

    /**
     * Returns the list of selectors.
     * Usable by derived classes.
     */
    protected final LinkedList<ISelector<T>> getSelectors() {
        return aSelectors;
    }

}
