/*
 * Created on Aug 15, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.tools.tine;

import de.desy.mst.auxiliary.devl.deviceserverlib.tools.StringUtils;


/**
 * Generates a local TINE name.
 * 
 * In addition to the export name, each equipment module
 * also hase a local name which is limited to 6 characters.
 * In order to prevent users from suplying two names,
 * a device server generates the local name from the
 * equipment name. The generated local name is an "L"
 * followed by a hash value of maximal 5 digits.
 *  
 * @author jwlg
 */
public class LocalNameGenerator {
    
    /**
     * Generates a local name.
     * @param exportName The export name.
     */
    public static String getLocalName(String exportName) {
        short hashCode = (short) StringUtils.getInstance().blochHash(exportName);
        if (hashCode < 0) {
            hashCode = (short)(Short.MAX_VALUE + hashCode);
        }
        return "L" + Short.toString(hashCode);
    }
    
}
