/*
 * CAMframeControlMBean.java
 *
 * Created on 09 August 2008, 16:27
 */

package de.desy.mst.libs.framework.mstapp.util.camInstrumentation;

/**
 * Interface CAMframeControlMBean
 *
 * @author karol
 */
public interface CAMframeControlMBean 
{

    /**
     * Get X-Position of the window
     */
    public int getX();

    /**
     * Set X-Position of the window
     */
    public void setX(int value);

    /**
     * Get Y-Position of the window
     */
    public int getY();

    /**
     * Set Y-Position of the window
     */
    public void setY(int value);

    /**
     * Get Width of the window
     */
    public int getWidth();

    /**
     * Set Width of the window
     */
    public void setWidth(int value);

    /**
     * Get Height of the window
     */
    public int getHeight();

    /**
     * Set Height of the window
     */
    public void setHeight(int value);

    /**
     * Moves window to the given position
     * @param newX new X-position
     * @param newY new Y-position
     */
    public void move(int newX, int newY);

    /**
     * newOperation1 Description
     * @param newWidth New width of the window
     * @param newHeight New height of the window
     */
    public void resize(int newWidth, int newHeight);

    /**
     * Close window
     */
    public void close();

    /**
     * returns identification string
     * @return java.lang.String
     */
    public String getId();

    /**
     * newOperation0 Description
     * @param x x
     * @param y y
     * @param width width
     * @param height height
     */
    public void setGeometry(int x, int y, int width, int height);

    /**
     * Get Window state (iconified,normal,maximized)
     */
    public int getState();

    /**
     * Set Window state (iconified,normal,maximized)
     */
    public void setState(int value);

    /**
     * newOperation0 Description
     * @param windowState Frame.ICONIFIED, Frame.NORMAL, etc...
     */
    public void windowState(int windowState);

}


