/*
 * File TGraphType.java
 *  
 * Authors Philip Duval (DESY), Jaka Bobnar (CosyLab), 
 *    Jan Szczesny (DESY), Karol Bartkiewicz (DESY), 
 *    Marcus Walla (DESY), Tobias Tempel (DESY)  
 *  
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023  
 *  
 * The TINE .java codeset made available by open source license
 * inherits several conceptual ideas from the original ISOLDE 
 * control system written in the C language ((c)CERN, released under 
 * a permissive CERN licence akin to the later well known MIT licence) 
 * in use at CERN in 1992. We therefore owe a substantial debt to CERN 
 * for its inception, and would be remiss if we did not express our 
 * gratitude in the JAVA TINE open source file headers, although none 
 * of the current Java software is in anyway a redistribution of 
 * software from the ISOLDE system of that era.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");  
 * You may not use this file except in compliance with the License.  
 * You may obtain a copy of the License at  
 *  
 * http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
 * See the License for the specific language governing permissions and  
 * limitations under the License.  
 */

/*
 * Created on Nov 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.definitions;

/**
 * \internal
 * 
 * @author duval
 *
 */
public final class TGraphType
{
  public static final short GT_LIN  = 0x00;
  public static final short GT_LOG  = 0x01;
  public static final short GT_SLOG = 0x02;
  public static final short GT_TD   = 0x03;
  public static final short GT_BIT  = 0x04;
  public static final short GT_TEXT = 0x05;
  public static final short GT_ABS  = 0x06;
  public static final short GT_HEX  = 0x07;
  public static String toString(short type)
  {
    switch (type)
    {
      default:
      case GT_LIN: return "LIN";
      case GT_LOG: return "LOG";
      case GT_SLOG: return "SLOG";
      case GT_TD: return "TD";
      case GT_BIT: return "BIT";
      case GT_TEXT: return "TEXT";
      case GT_ABS: return "ABS";
      case GT_HEX: return "HEX";
    }
  }
  public static short getType(String txt)
  {
    if (txt == null) return GT_LIN;
    if (txt.compareToIgnoreCase("LIN") == 0) return GT_LIN;
    if (txt.compareToIgnoreCase("LOG") == 0) return GT_LOG;
    if (txt.compareToIgnoreCase("SLOG") == 0) return GT_SLOG;
    if (txt.compareToIgnoreCase("TD") == 0) return GT_TD;
    if (txt.compareToIgnoreCase("BIT") == 0) return GT_BIT;
    if (txt.compareToIgnoreCase("TEXT") == 0) return GT_TEXT;
    if (txt.compareToIgnoreCase("ABS") == 0) return GT_ABS;
    if (txt.compareToIgnoreCase("HEX") == 0) return GT_HEX;
    return GT_LIN;
  }
}
