package de.desy.tine.eventArchive;
import java.io.*;
import de.desy.tine.endianUtils.*;
public class AESnotify
{
  public int version;
  public int eventNumber;
  public int eventCode;
  public int reserved;
  public String comment = new String(new StringBuffer(256));
  public static int sizeInBytes = (4*4 + 256);
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public byte[] toByteArray()
  {
    try
	{
		dBuffer.reset();
		DataOutputStream ds = new DataOutputStream(dBuffer);
		ds.writeInt(Swap.Int(version));
		ds.writeInt(Swap.Int(eventNumber));
		ds.writeInt(Swap.Int(eventCode));
		ds.writeInt(Swap.Int(reserved));
		byte[] bstr = new byte[256];
		byte[] tmp  = comment.getBytes();
		for (int i=0; i<256; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
		ds.write(bstr,0,256);
		ds.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
	  System.exit(1);
	}	 
	hByteArray = dBuffer.toByteArray();
	return hByteArray;
  }
  public void toStruct()
  {
	try
	{
		ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
		DataInputStream ds = new DataInputStream(dis);
		version = Swap.Int(ds.readInt());
		eventNumber = Swap.Int(ds.readInt());
		eventCode = Swap.Int(ds.readInt());
		reserved = Swap.Int(ds.readInt());
		byte[] bstr = new byte[256];
		ds.read(bstr,0,256);
		comment = new String(bstr);
		ds.close(); dis.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
	  System.exit(1);
	}	 
  }
}