package de.desy.tine.eventArchive;

import de.desy.tine.structUtils.TTaggedStructure;

public class TrgCmp extends TTaggedStructure
{
  public void clear()
  {
    contextString = null;
    serverString = null;
    triggerString = null;
    descriptionString = null;
  }
  private char[] context = new char[32];
  private String contextString;
  private char[] server = new char[32];
  private String serverString;
  private char[] trigger = new char[64];
  private String triggerString;
  private char[] description = new char[64];
  private String descriptionString;
  private void initStructure()
  {
    addField(context,"context");
    addField(server,"server");
    addField(trigger,"trigger");
    addField(description,"description");
    initDone();    
  }
  public TrgCmp()
  {
    super();
    initStructure();
  }
  public TrgCmp(TrgCmp reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.context, 0, context, 0, 32);    
    System.arraycopy(reference.server, 0, server, 0, 32);    
    System.arraycopy(reference.trigger, 0, trigger, 0, 64);    
    System.arraycopy(reference.description, 0, description, 0, 64);
  }
  public String getContext()
  {
    if (contextString == null) contextString = new String(context).trim();
    return contextString;
  }
  public String getDescription()
  {
    if (descriptionString == null) descriptionString = new String(description).trim();
    return descriptionString;
  }
  public String getTrigger()
  {
    if (triggerString == null) triggerString = new String(trigger).trim();
    return triggerString;
  }
  public String getServer()
  {
    if (serverString == null) serverString = new String(server).trim();
    return serverString;
  }
  public void setContext(String context) 
  {
    Util.pushChars(context,this.context);
    this.contextString = new String(context);
  }
  public void setDescription(String description) 
  {
    Util.pushChars(description,this.description);
    this.descriptionString = new String(description);
  }
  public void setServer(String server) 
  {
    Util.pushChars(server,this.server);
    this.serverString = new String(server);
  }
  public void setTrigger(String trigger) 
  {
    Util.pushChars(trigger,this.trigger);
    this.triggerString = new String(trigger);
  }
}
