/*
 * File SelfTestItem.java
 *  
 * Authors Philip Duval (DESY), Jaka Bobnar (CosyLab), 
 *    Jan Szczesny (DESY), Karol Bartkiewicz (DESY), 
 *    Marcus Walla (DESY), Tobias Tempel (DESY)  
 *  
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023  
 *  
 * The TINE .java codeset made available by open source license
 * inherits several conceptual ideas from the original ISOLDE 
 * control system written in the C language ((c)CERN, released under 
 * a permissive CERN licence akin to the later well known MIT licence) 
 * in use at CERN in 1992. We therefore owe a substantial debt to CERN 
 * for its inception, and would be remiss if we did not express our 
 * gratitude in the JAVA TINE open source file headers, although none 
 * of the current Java software is in anyway a redistribution of 
 * software from the ISOLDE system of that era.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");  
 * You may not use this file except in compliance with the License.  
 * You may obtain a copy of the License at  
 *  
 * http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
 * See the License for the specific language governing permissions and  
 * limitations under the License.  
 */

package de.desy.tine.queryUtils;

import de.desy.tine.dataUtils.*;

public class SelfTestItem
{
  public String getPrp()
  {
    return prp;
  }
  public void setPrp(String prp)
  {
    this.prp = prp;
  }
  public String getDev()
  {
    return dev;
  }
  public void setDev(String dev)
  {
    this.dev = dev;
  }
  public TDataType getDout()
  {
    return dout;
  }
  public void setDout(TDataType dout)
  {
    this.dout = dout;
  }
  public TDataType getDin()
  {
    return din;
  }
  public void setDin(TDataType din)
  {
    this.din = din;
  }
  public String getTgt()
  {
    return tgt;
  }
  public void setTgt(String tgt)
  {
    this.tgt = tgt;
  }
  public String getInpt()
  {
    return inpt;
  }
  public void setInpt(String inpt)
  {
    this.inpt = inpt;
  }
  public int getAcc()
  {
    return acc;
  }
  public void setAcc(int acc)
  {
    this.acc = acc;
  }
  public float getTolAbs()
  {
    return tolAbs;
  }
  public void setTolAbs(float tolAbs)
  {
    this.tolAbs = tolAbs;
  }
  public float getTolRel()
  {
    return tolRel;
  }
  public void setTolRel(float tolRel)
  {
    this.tolRel = tolRel;
  }
  public String getReq()
  {
    return req;
  }
  public void setReq(String req)
  {
    this.req = req;
  }
  public int getMask()
  {
    return msk;
  }
  public void setMask(int mask)
  {
    this.msk = mask;
  }
  private String prp;
  private String dev;
  private TDataType dout;
  private TDataType din;
  private String tgt;
  private String inpt;
  private int acc;
  private int msk;
  private float tolAbs;
  private float tolRel;
  private String req;
  public SelfTestItem(String device,String property,TDataType dout,TDataType din,int access,float toleranceAbsolute,float toleranceRelative,String stateRequirement)
  {
    prp = property;
    dev = device;
    this.dout = dout;
    this.din = din;
    acc = access;
    tolAbs = toleranceAbsolute;
    tolRel = toleranceRelative;
    req = stateRequirement;
  }
}
