/*
 * File TActivityStruct.java
 *  
 * Authors Philip Duval (DESY), Jaka Bobnar (CosyLab), 
 *    Jan Szczesny (DESY), Karol Bartkiewicz (DESY), 
 *    Marcus Walla (DESY), Tobias Tempel (DESY)  
 *  
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023  
 *  
 * The TINE .java codeset made available by open source license
 * inherits several conceptual ideas from the original ISOLDE 
 * control system written in the C language ((c)CERN, released under 
 * a permissive CERN licence akin to the later well known MIT licence) 
 * in use at CERN in 1992. We therefore owe a substantial debt to CERN 
 * for its inception, and would be remiss if we did not express our 
 * gratitude in the JAVA TINE open source file headers, although none 
 * of the current Java software is in anyway a redistribution of 
 * software from the ISOLDE system of that era.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");  
 * You may not use this file except in compliance with the License.  
 * You may obtain a copy of the License at  
 *  
 * http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
 * See the License for the specific language governing permissions and  
 * limitations under the License.  
 */

/*
 * Created on Mar 12, 2007
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server;

import de.desy.tine.structUtils.TTaggedStructure;

public class TActivityStruct extends TTaggedStructure
{
  private char[] fecName = new char[16];
  private byte[] reserved = new byte[4]; 
  private int[] localtime = new int[1];
  private int[] starttime = new int[1];
  private int[] systemPollingRate = new int[1];
  private short[] numBkgTsks = new short[1];
  private short[] numTotalContracts = new short[1];
  private short[] numTotalClients = new short[1];
  private short[] numTargetContracts = new short[1];
  private short[] numTargetClients = new short[1];
  private short[] numConnections = new short[1];
  private int[] numConnectionTimeouts = new int[1];
  private int[] numConnectionArrivals = new int[1];
  private int[] numUdpPkts = new int[1];
  private int[] numTcpPkts = new int[1];
  private int[] numIpxPkts = new int[1];
  private int[] numSpxPkts = new int[1];

  public TActivityStruct()
  {
    super("AQS");
    addField(fecName,"fecName");
    addField(reserved,"reserved");
    addField(localtime,"localtime");
    addField(starttime,"starttime");
    addField(systemPollingRate,"systemPollingRate");
    addField(numBkgTsks,"numBkgTsks");
    addField(numTotalContracts,"numTotalContracts");
    addField(numTotalClients,"numTotalClients");
    addField(numTargetContracts,"numTargetContracts");
    addField(numTargetClients,"numTargetClients");
    addField(numConnections,"numConnections");
    addField(numConnectionTimeouts,"numConnectionTimeouts");
    addField(numConnectionArrivals,"numConnectionArrivals");
    addField(numUdpPkts,"numUdpPkts");
    addField(numTcpPkts,"numTcpPkts");
    addField(numIpxPkts,"numIpxPkts");
    addField(numSpxPkts,"numSpxPkts");
    initDone();
  }

  public char[] getFecName()
  {
    return fecName;
  }

  public int[] getLocaltime()
  {
    return localtime;
  }

  public short[] getNumBkgTsks()
  {
    return numBkgTsks;
  }

  public int[] getNumConnectionArrivals()
  {
    return numConnectionArrivals;
  }

  public short[] getNumConnections()
  {
    return numConnections;
  }

  public int[] getNumConnectionTimeouts()
  {
    return numConnectionTimeouts;
  }

  public int[] getNumIpxPkts()
  {
    return numIpxPkts;
  }

  public int[] getNumSpxPkts()
  {
    return numSpxPkts;
  }

  public short[] getNumTargetClients()
  {
    return numTargetClients;
  }

  public int[] getNumTcpPkts()
  {
    return numTcpPkts;
  }

  public short[] getNumTotalClients()
  {
    return numTotalClients;
  }

  public short[] getNumTotalContracts()
  {
    return numTotalContracts;
  }

  public int[] getNumUdpPkts()
  {
    return numUdpPkts;
  }

  public byte[] getReserved()
  {
    return reserved;
  }

  public int[] getStarttime()
  {
    return starttime;
  }

  public int[] getSystemPollingRate()
  {
    return systemPollingRate;
  }
  
}
