/*
 * File TAlarmDescriptor.java
 *  
 * Authors Philip Duval (DESY), Jaka Bobnar (CosyLab), 
 *    Jan Szczesny (DESY), Karol Bartkiewicz (DESY), 
 *    Marcus Walla (DESY), Tobias Tempel (DESY)  
 *  
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023  
 *  
 * The TINE .java codeset made available by open source license
 * inherits several conceptual ideas from the original ISOLDE 
 * control system written in the C language ((c)CERN, released under 
 * a permissive CERN licence akin to the later well known MIT licence) 
 * in use at CERN in 1992. We therefore owe a substantial debt to CERN 
 * for its inception, and would be remiss if we did not express our 
 * gratitude in the JAVA TINE open source file headers, although none 
 * of the current Java software is in anyway a redistribution of 
 * software from the ISOLDE system of that era.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");  
 * You may not use this file except in compliance with the License.  
 * You may obtain a copy of the License at  
 *  
 * http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
 * See the License for the specific language governing permissions and  
 * limitations under the License.  
 */

/*
 * Created on Aug 23, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server.alarms;

public class TAlarmDescriptor
{
  public static final short NEW = 0x01;
  public static final short HEARTBEAT = 0x02;
  public static final short OSCILLATION = 0x04;
  public static final short DATACHANGE = 0x08;
  public static final short INSTANT = 0x10;
  public static final short TRANSIENT = 0x10;
  public static final short DISABLED =0x20; // set only by the CAS
  public static final short TERMINATE = 0x40;
  public static final short TEST = 0x80;
  public static final short SUPPRESS = 0x80;
  public static String toString(short descriptor)
  {
    String s = "";
    if ((descriptor & NEW) == NEW) s = s + "N";
    if ((descriptor & HEARTBEAT) == HEARTBEAT) s = s + "H";
    if ((descriptor & OSCILLATION) == OSCILLATION) s = s + "O";
    if ((descriptor & DATACHANGE) == DATACHANGE) s = s + "C";
    if ((descriptor & INSTANT) == INSTANT) s = s + "I";
    if ((descriptor & TERMINATE) == TERMINATE) s = s + "E";
    //if ((descriptor & TEST) == TEST) s = s + "T";
    if ((descriptor & SUPPRESS) == SUPPRESS) s = s + "S";
    return s;
  }
  public static String toLongString(short descriptor)
  {
    String s = "";
    if ((descriptor & NEW) == NEW) s = s + "New ";
    if ((descriptor & HEARTBEAT) == HEARTBEAT) s = s + "Heartbeat ";
    if ((descriptor & OSCILLATION) == OSCILLATION) s = s + "Oscillating ";
    if ((descriptor & DATACHANGE) == DATACHANGE) s = s + "Data Changed ";
    if ((descriptor & INSTANT) == INSTANT) s = s + "Transient ";
    if ((descriptor & TERMINATE) == TERMINATE) s = s + "Terminated ";
    if ((descriptor & SUPPRESS) == SUPPRESS) s = s + "Suppressed ";
    return s;
  }
}
