/*
 * File NAME64TIME.java
 *  
 * Authors Philip Duval (DESY), Jaka Bobnar (CosyLab), 
 *    Jan Szczesny (DESY), Karol Bartkiewicz (DESY), 
 *    Marcus Walla (DESY), Tobias Tempel (DESY)  
 *  
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023  
 *  
 * The TINE .java codeset made available by open source license
 * inherits several conceptual ideas from the original ISOLDE 
 * control system written in the C language ((c)CERN, released under 
 * a permissive CERN licence akin to the later well known MIT licence) 
 * in use at CERN in 1992. We therefore owe a substantial debt to CERN 
 * for its inception, and would be remiss if we did not express our 
 * gratitude in the JAVA TINE open source file headers, although none 
 * of the current Java software is in anyway a redistribution of 
 * software from the ISOLDE system of that era.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");  
 * You may not use this file except in compliance with the License.  
 * You may obtain a copy of the License at  
 *  
 * http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
 * See the License for the specific language governing permissions and  
 * limitations under the License.  
 */

package de.desy.tine.types;

import de.desy.tine.dataUtils.TDataTime;
import de.desy.tine.definitions.TFormat;

public final class NAME64TIME extends NAME64DBL
{
  private static short dFormat = TFormat.CF_NAME64TIME;
  public short getFormat() { return dFormat; }    
  public NAME64TIME() {name = new String(new StringBuffer(64)); dval = 0;}  
  public NAME64TIME(String Name) { name = Name; dval = 0;}  
  public NAME64TIME(String Name,double d) { name = Name; dval = d;}  
  public NAME64TIME(NAME64TIME instance) 
  { 
    name = instance.name == null ? new String(new StringBuffer(64)) : new String(instance.name); 
    dval = instance.dval; 
  }
  public NAME64TIME(NAME64DBL instance) 
  { 
    name = instance.name == null ? new String(new StringBuffer(64)) : new String(instance.name); 
    dval = instance.dval; 
  }
  public String toString()
  {
      return "["+ name + separator + TDataTime.toString(dval) + "]";
  } 
  public NAME64TIME clone()
  {
    return new NAME64TIME(this);
  }            
}
