/*
 * File NAME8I.java
 *  
 * Authors Philip Duval (DESY), Jaka Bobnar (CosyLab), 
 *    Jan Szczesny (DESY), Karol Bartkiewicz (DESY), 
 *    Marcus Walla (DESY), Tobias Tempel (DESY)  
 *  
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023  
 *  
 * The TINE .java codeset made available by open source license
 * inherits several conceptual ideas from the original ISOLDE 
 * control system written in the C language ((c)CERN, released under 
 * a permissive CERN licence akin to the later well known MIT licence) 
 * in use at CERN in 1992. We therefore owe a substantial debt to CERN 
 * for its inception, and would be remiss if we did not express our 
 * gratitude in the JAVA TINE open source file headers, although none 
 * of the current Java software is in anyway a redistribution of 
 * software from the ISOLDE system of that era.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");  
 * You may not use this file except in compliance with the License.  
 * You may obtain a copy of the License at  
 *  
 * http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
 * See the License for the specific language governing permissions and  
 * limitations under the License.  
 */

package de.desy.tine.types;

public final class NAME8I extends NAMEINT implements TCompoundDataObject
{
  public NAME8I(NAME8I instance) { super(8); name = instance.name; ival = instance.ival; }
  public void copy(TCompoundDataObject from)
  {
    if (from instanceof NAME8I)
    {
      NAME8I instance = (NAME8I)from;
      name = instance.name;
      ival = instance.ival;
    }
  }
  public boolean equals(NAME8I instance) { return super.equals(instance); }
  public NAME8I newInstance()
  {
    return new NAME8I();
  }
  public NAME8I clone()
  {
    return new NAME8I(this);
  }          
  public NAME8I() 
  {
    super(8);
  }  
  public NAME8I(String Name) 
  {
    super(8);
    if (Name != null) name = Name;
  }  
  public NAME8I(String Name,int i) 
  {
    super(8);
    if (Name != null) name = Name;
    ival = i;
  }  
}