package de.desy.video.sw;

// big memory for testing:
// 	-Xms512m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=128m


import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Canvas;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.Color;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.ComponentAdapter;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JRadioButton;
import java.awt.GridBagConstraints;
import javax.swing.SwingConstants;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import java.awt.event.KeyEvent;
import java.awt.image.MemoryImageSource;
import java.awt.HeadlessException;
import java.awt.Point;

import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.ComponentOrientation;
import javax.swing.BorderFactory;
import javax.swing.border.BevelBorder;

import de.desy.tine.client.TLink;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TAccess;
import de.desy.tine.definitions.TMode;
import de.desy.tine.client.*;
//import de.desy.tine.dataUtils.*;
//import de.desy.tine.definitions.*;
import de.desy.tine.types.*;

import java.awt.Insets;
import java.awt.AlphaComposite;
import java.awt.Composite;
import javax.swing.JOptionPane;

//import java.awt.FileDialog;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;

import java.io.File;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


/**
 * @deprecated 
 */
public final class CFastImageDisplayer extends Frame implements TLinkCallback {

	private static final long serialVersionUID = 1L;
	private java.awt.image.BufferStrategy m_FlipStrategy=null;
	private JPanel jControlPanel = null;
	private JRadioButton jRBColorGreyscale = null;
	private JRadioButton jRBColorPITZ = null;
	private JRadioButton jRBColorJet = null;
	private JPanel jControlSubPanel = null;
	private JCheckBox jCBOverlay = null;
	private JCheckBox jCBAOIZoom = null;
	private JCheckBox jCBKeepAspectRatio = null;
	private JPanel jControlSubPanel2 = null;
	private JLabel jLabelAddress = null;
	private JTextField jTFAddress = null;
	private JPanel jControlPanel3 = null;
	private JButton jBStart = null;
	private JButton jBStop = null;
	private JButton jBSaveAsPNG = null;
	private JButton jBQuit = null;
	private Canvas m_VideoCanvas = null;

	private boolean m_bOverlayEnabled;
	private boolean m_bVideoCanvasMouseInOverlay;
	private boolean m_bVideoCanvasMouseInCanvas;
	private boolean m_bVideoCanvasMouseLeftButtonDown;
	private boolean m_bAOIZoom;
	private boolean m_bKeepAspectRatioEnabled;
	private boolean m_bTransferRunning=false;
	private boolean m_bFalsecolorEnabled=true;
	private CFastImageDisplayer m_selfRef=null;
	//TINE
	private TLink m_vidLink = null;  //  @jve:decl-index=0:

	private final int minx = 592;
	private final int miny = 211; // 127 + 2x42 OSD;
	
	// buffers to work with
	IMAGE m_srcImgHdr = null;  //  @jve:decl-index=0:
	byte[] m_dstBuf = null;
	byte[] m_srcBuf = null;

	int[] m_DisplayImageBuffer = null;// = new int[hdr.width*hdr.height];
	int[] m_ColorLookupTableArray = null; //mapping from
	CColorLookupTable m_CColorLookupTable = null;

	private long m_lastframenumber=-1;
	private long m_droppedframes=0;
	private long m_receivedframes=0;
	private double m_ratio = -0.001;
	
	Image m_img=null;  //  @jve:decl-index=0:
	MemoryImageSource m_mis=null;  //  @jve:decl-index=0:
	
	int m_iColorMode = CColorLookupTable.FALSEPITZ;
	boolean m_bDoUpdateColorLookupTable = true;
	CVideoHeader3 m_Hdr = null;  //  @jve:decl-index=0:
	
	/**
	 * This is the default constructor
	 */

	// SW!  String aDefaultStartupServer 
	public CFastImageDisplayer() {
		super();

		m_selfRef = this;
		
		initialize();
		
		//pack();
		this.setVisible(true);
		m_VideoCanvas.createBufferStrategy(2);
		m_FlipStrategy = m_VideoCanvas.getBufferStrategy();
		
		m_CColorLookupTable = new CColorLookupTable();
		
	}

	private void QuitCleanupApplication()
	{
		System.out.println("Cleaning up TINE transfer (if necessary)...");
		doStopTransfer();
		System.out.println("TINE transfer cleaned up.");
		
		System.exit(0);
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(559, 387);
		this.setMinimumSize(new Dimension(minx, miny));
		this.setTitle("jtDVD - java tine Digital Video Display");

		m_VideoCanvas = new Canvas();
		m_VideoCanvas.setBackground(new Color(80,80,80));
		m_VideoCanvas.setBounds(5, 5, 200, 200);
		m_VideoCanvas.setIgnoreRepaint(true);
		m_VideoCanvas.addMouseListener( new MouseAdapter() {
			public void mouseExited(MouseEvent e)
			{
				boolean old = m_bVideoCanvasMouseInOverlay; 
				m_bVideoCanvasMouseInOverlay = false;
				m_bVideoCanvasMouseInCanvas = false;
				//m_bVideoCanvasMouseLeftButtonDown = false;
				//System.out.println("Mouse exited.");
				if (old == true) repaintAnything();
			}
			
			public void mouseEntered(MouseEvent e)
			{
				boolean old = m_bVideoCanvasMouseInOverlay; 
				//m_bVideoCanvasMouseInOverlay = true;
				m_bVideoCanvasMouseInCanvas = true;
				//m_bVideoCanvasMouseLeftButtonDown = false;
				//System.out.println("Mouse exited.");
				if (old == true) repaintAnything();
			}
			
			public void mousePressed(MouseEvent e)
			{
				//if (e.getModifiers() == MouseEvent.BUTTON1_DOWN_MASK)
					m_bVideoCanvasMouseLeftButtonDown = true;
			
			}
	          
			public void mouseReleased(MouseEvent e)
			{
				//if (e.getModifiers() == MouseEvent.BUTTON1_DOWN_MASK)
					m_bVideoCanvasMouseLeftButtonDown = false;
		
			}
			
		});
		
		
		m_VideoCanvas.addMouseMotionListener( new MouseMotionAdapter() {
			public void mouseMoved(MouseEvent e) 
			{
				//int xpos = e.getX();
				int ypos = e.getY();
				
				//boolean old = m_bVideoCanvasMouseInOverlay; 
								
				if (((ypos>0) && (ypos<50)) ||((ypos > m_VideoCanvas.getHeight()-50) && (ypos < m_VideoCanvas.getHeight())))
					m_bVideoCanvasMouseInOverlay = true;
				
				if (((ypos<=0) || (ypos >= m_VideoCanvas.getHeight())))				
					m_bVideoCanvasMouseInOverlay = false;

				m_bVideoCanvasMouseInCanvas = true;

				if (m_bTransferRunning == false) repaintAnything();
				
				//if (old != m_bMouseInOverlay) repaintAnything();
				
			}
		});
		
		this.add(m_VideoCanvas, BorderLayout.CENTER);
		this.add(getJControlPanel(), BorderLayout.SOUTH);

		jRBColorGreyscale.setSelected(false);
		jRBColorPITZ.setSelected(true);
		jRBColorJet.setSelected(false);
		
		m_iColorMode = CColorLookupTable.FALSEPITZ;
		m_bDoUpdateColorLookupTable = true;
		
		jCBOverlay.setSelected(false);
		m_bOverlayEnabled = false;
		m_bVideoCanvasMouseInOverlay = false;
		m_bVideoCanvasMouseInCanvas = false;
		m_bVideoCanvasMouseLeftButtonDown = false;
		
		jCBAOIZoom.setSelected(false);
		m_bAOIZoom = false;
		jCBKeepAspectRatio.setSelected(true);
		
		jBStop.setEnabled(false);
		jBSaveAsPNG.setEnabled(false);
		
		this.addWindowListener(new WindowAdapter(){
			public void windowClosed(WindowEvent arg0) {
				// super.windowClosed(arg0);
				//System.out.println("windowClosed");
			}
			
			public void windowClosing(WindowEvent arg0) {
				//System.out.println("windowClosing");
				super.windowClosing(arg0);
				QuitCleanupApplication();
				
			}
		});
		
		this.addComponentListener(new ComponentAdapter(){
			public void componentResized(ComponentEvent arg0) 
			{
				repaint();
			}

			public void componentMoved(ComponentEvent arg0) 
			{
				repaint();
			}

			public void componentShown(ComponentEvent arg0)
			{
				repaint();
			}
		});
	}

	private AlphaComposite makeComposite(float alpha) 
	{
		int type = AlphaComposite.SRC_OVER;
		return(AlphaComposite.getInstance(type, alpha));
	}

	
	//public synchronized void updateImage( Image img, long aFrameNumber )
	public void updateImage()
	{
	
		if (m_Hdr == null) return;
		
		
	    Graphics g=null;
	    do 
	    {
	    	// The following loop ensures that the contents of the drawing buffer
	        // are consistent in case the underlying surface was recreated
	        do 
	        {
	        	try 
	        	{
	    	    	g = (java.awt.Graphics2D) m_FlipStrategy.getDrawGraphics();
	    			java.awt.Graphics2D g2d= (java.awt.Graphics2D)g;
	    			
    				m_VideoCanvas.paint(g);
	    			
	    			if (m_img != null)
	    			{
    					java.awt.Rectangle imgR = new java.awt.Rectangle();
    					java.awt.Rectangle srcR = new java.awt.Rectangle();
    					java.awt.Rectangle dstR = new java.awt.Rectangle();;
    					java.awt.Rectangle dstROrig = new java.awt.Rectangle();;

    					imgR.x = 0;
    					imgR.y = 0;
    					imgR.width = m_Hdr.frameHeader.sourceWidth;
    					imgR.height = m_Hdr.frameHeader.sourceHeight;
    						
    					srcR.x = m_Hdr.frameHeader.xStart;
    					srcR.y = m_Hdr.frameHeader.yStart;
    					srcR.width = m_Hdr.frameHeader.aoiWidth;
    					srcR.height = m_Hdr.frameHeader.aoiHeight;
    					if (srcR.width == -1) srcR.width = imgR.width;
    					if (srcR.height == -1) srcR.height = imgR.height;
    					    					
    					dstROrig.x = 2;
    					dstROrig.y = 2;
    					dstROrig.width = m_VideoCanvas.getWidth()-4;
    					dstROrig.height = m_VideoCanvas.getHeight()-4;

    					dstR.x = 2;
    					dstR.y = 2;
    					dstR.width = m_VideoCanvas.getWidth()-4;
    					dstR.height = m_VideoCanvas.getHeight()-4;
    					
    					//dstR = dstROrig;
    					
						if (m_bKeepAspectRatioEnabled == true)
	    				{
    					    double whratiovideo = 1.0;
    						if (imgR.height > 0) whratiovideo = ((double)imgR.width)/((double)imgR.height);

	    					for (;;)
	    					{
	    						dstR.height = (int) Math.round(((double)dstR.width)/whratiovideo);
	    						if (dstR.height > dstROrig.height) 
	    						{ 
	    							dstR.width--; 
	    							continue; 
	    						}
	    						else 
									if (dstR.width <= dstROrig.width) break; else dstR.width = dstROrig.width-1;
	    					}

	    					dstR.x=dstROrig.x+((dstROrig.width-dstR.width)/2);
	    					dstR.y=dstROrig.y+((dstROrig.height-dstR.height)/2);
	    				}
	    				

    					
	    				// after: now width and height are adjusted properly to canvas for whole big image
    					if ((m_bAOIZoom == false) && ((srcR.width != imgR.width) || (srcR.height != imgR.height)))
	    				{
    	       				g2d.setColor(new Color(0,0,0)); // DARK_
    	       				g2d.fillRect(dstR.x, dstR.y, dstR.width, dstR.height);
	    				}

    					if (m_bAOIZoom == true)
    					{
    						
    						if (m_bKeepAspectRatioEnabled == true)
    						{
    							int widthaoi = srcR.width;
    							int heightaoi = srcR.height;
        						
        						
    							double whratioaoi = 1.0;
    							if (heightaoi > 0) whratioaoi = ((double)widthaoi)/((double)heightaoi);

    							//heightaoi = height;
    							widthaoi = dstROrig.width;
    							
    							for (;;)
    							{
    								heightaoi = (int) Math.round(((double)widthaoi)/whratioaoi);
    								if (heightaoi > dstROrig.height) 
    								{ 
    									widthaoi--; 
    									continue;
    								}
    								else
    									if (widthaoi <= dstROrig.width) break; 
    									else 
    									{
    										widthaoi = dstROrig.width;
    									}
    							}

    							dstR.width = widthaoi;
    	    					dstR.height = heightaoi;
   							
    						}

	    					dstR.x=dstROrig.x+((dstROrig.width-dstR.width)/2);
	    					dstR.y=dstROrig.y+((dstROrig.height-dstR.height)/2);
    					}
    					else
    					{
   							double wscale_full = (dstR.width*1.0/imgR.width*1.0);
   							double hscale_full = (dstR.height*1.0/imgR.height*1.0);

   							dstR.width = (int) Math.round(srcR.width*wscale_full); 
   							dstR.height = (int) Math.round(srcR.height*hscale_full);
   							
   							dstR.x+=((int) (srcR.x*wscale_full));
   							dstR.y+=((int) (srcR.y*hscale_full));
    					}
	    				
    					g2d.drawImage(m_img, dstR.x, dstR.y, dstR.width, dstR.height, null);
	    				
    	    			String sAddPixelValue = "";
    	    			
    	    			if ((m_bOverlayEnabled == true) || (m_bVideoCanvasMouseInOverlay == true))
    	    			{
    	    				if ((m_bVideoCanvasMouseInCanvas == true) && (m_bVideoCanvasMouseLeftButtonDown == true))
    	    				{
    	    					sAddPixelValue = "";
    	    					try{
    	    						Point p = m_VideoCanvas.getMousePosition();
    	    						if (p != null)
    	    						{
    	    	    					int pixelindex = 0; 

    	    	    					sAddPixelValue += "  (out of dimension)";

    	    	    					if (((p.x>=dstR.x) && (p.x<=(dstR.x+dstR.width))) && ((p.y>=dstR.y) && (p.y<=(dstR.y+dstR.height))))
    	    	    					{
        	    	    					// do coordinate transform, src, dst
    	    	    						
    	    	    						double dst2srcWidthRelation = 1.0*srcR.width / dstR.width;
    	    	    						double dst2srcHeightRelation =  1.0*srcR.height / dstR.height;
    	    	    						    	    	    						
    	    	    						int pixelx = (int) ((1.0*(p.x-dstR.x))*dst2srcWidthRelation);
    	    	    						int pixely = (int) ((1.0*(p.y-dstR.y))*dst2srcHeightRelation);
    	    	    						if (pixelx >= srcR.width) pixelx = srcR.width-1; 
    	    	    						if (pixely >= srcR.height) pixely = srcR.height-1;
    	    	    							    	    						
    	    	    						pixelindex = (srcR.width*pixely+pixelx)*m_Hdr.frameHeader.bytesPerPixel;
    	    	    						
    		    	    					sAddPixelValue = "  px("+(pixelx+1+srcR.x)+","+(pixely+1+srcR.y)+") = ";
    		    	    					// debug:
    		    	    					//sAddPixelValue = "  ("+p.x+"/"+p.y+")   px("+(pixelx+1+srcR.x)+","+(pixely+1+srcR.y)+") = ";
    	    	    						
    	    	    						if (m_Hdr.frameHeader.imageFormat == CVideoHeader3.CF_IMAGE_FORMAT_GRAY)
    	    	    						{
    	    	    							long pxvalue = ((long)m_dstBuf[pixelindex])&0xff;
    	    	    							if (m_Hdr.frameHeader.bytesPerPixel > 1) pxvalue |= (((long)m_dstBuf[pixelindex+1])&0xff)<<8;
    	    	    							if (m_Hdr.frameHeader.bytesPerPixel > 2) pxvalue |= (((long)m_dstBuf[pixelindex+2])&0xff)<<16;
    	    	    							if (m_Hdr.frameHeader.bytesPerPixel > 3) pxvalue |= (((long)m_dstBuf[pixelindex+3])&0xff)<<24;

    	    	    							int maxpxvalue = (1 << m_Hdr.frameHeader.effectiveBitsPerPixel)-1;
    	    	    								
    	    	    							sAddPixelValue += pxvalue+" (out of "+maxpxvalue+")";
    	    	    						}
    	    	    						else if (m_Hdr.frameHeader.imageFormat == CVideoHeader3.CF_IMAGE_FORMAT_RGB)
    	    	    						{
    	    	    							long redvalue = ((long)m_dstBuf[pixelindex])&0xff;
    	    	    							long greenvalue = ((long)m_dstBuf[pixelindex+1])&0xff;
    	    	    							long bluevalue = ((long)m_dstBuf[pixelindex+2])&0xff;
      	    							
    	    	    							sAddPixelValue += "("+redvalue+"/"+greenvalue+"/"+bluevalue+")";
    	    	    						}
    	    	    						else
    	    	    						{
    	    	    							sAddPixelValue += "(unknown)";
    	    	    						}
    	    	    					}
    	    							
    	    						}
    	    					}
    	    					catch( HeadlessException ex1 )
    	    					{
    	    					}
    	    					
    	    					
    	    				}
    	    				
    	    			}
    	    			
    	    			if ((m_bOverlayEnabled == true) || (m_bVideoCanvasMouseInOverlay == true))
    	    			{
    	       				Composite originalComposite = g2d.getComposite();	       				
    	       				g2d.setColor(new Color(190,190,190)); // DARK_
    	       				g2d.setComposite(makeComposite(0.85F));
    	       				g2d.fillRect(2, 2, m_VideoCanvas.getWidth()-4, 40 );
    	       				g2d.fillRect(2, m_VideoCanvas.getHeight()-42, m_VideoCanvas.getWidth()-4, 40 );	       				
    	       				g2d.setComposite(originalComposite);
    	       					       				
    	       				g2d.setColor(new Color(0,0,0));
    	       				
    	       				String s = "Source: "+m_Hdr.sourceHeader.cameraPortName+" ("+CVideoHeader3.formatToString(m_Hdr.frameHeader.sourceFormat)+")";
    	       				g2d.drawString(s, 10, 16);
    	       				
    	       				s = "Size: "+m_Hdr.frameHeader.sourceWidth+" px * "+m_Hdr.frameHeader.sourceHeight+" px";
    	       				
    	       				if ((m_Hdr.frameHeader.aoiWidth != -1) || (m_Hdr.frameHeader.aoiHeight != -1))
    	       				{
    	       					s+="  (AOI: L "+m_Hdr.frameHeader.xStart+", T "+m_Hdr.frameHeader.yStart+
    	       								", W "+m_Hdr.frameHeader.aoiWidth+", H "+m_Hdr.frameHeader.aoiHeight+" )";
    	       				}
    	       				else
    	       					s+="  (AOI: none)";
    	       				g2d.drawString(s,10,34);
    	       				
    	       				DateFormat dfmt = new SimpleDateFormat("HH:mm:ss.SSS");
    	       				
    	       				s = "# "+m_Hdr.frameHeader.frameNumber+" - "+dfmt.format(m_Hdr.getTimestampAsDate());
    	       				g2d.drawString(s, m_VideoCanvas.getWidth()-g2d.getFontMetrics().stringWidth(s)-10, 16);
    	       				
    	       				s = "Drop: "+m_droppedframes+" ("+String.format("%4.3f", 
    	       						new java.lang.Object[]{Double.valueOf(m_ratio*100.0)})+"%)";
    	       				g2d.drawString(s, m_VideoCanvas.getWidth()-g2d.getFontMetrics().stringWidth(s)-10, 34);
    	       				
    	       				s = "Format: "+CVideoHeader3.formatToString(m_Hdr.frameHeader.imageFormat);
    	       				s += sAddPixelValue;
    	       				g2d.drawString(s, 10, m_VideoCanvas.getHeight()-26 );
    	       				
    	       				s = "Flags: "+CVideoHeader3.flagsToString(m_Hdr.frameHeader.imageFlags);
    	       				g2d.drawString(s, 10, m_VideoCanvas.getHeight()-8 );
    	       				
    	       				double rot = m_Hdr.frameHeader.imageRotation; 
    	       				
           					double rotAbs = Math.abs(rot);
    	       				
           					s = "Rotation: "+String.format("%4.2f", 
    	       						new java.lang.Object[]{Double.valueOf(rotAbs)})+"%";
           					
           					if (rot > 0.0) s += " cw";
           					else if (rot < 0.0) s += " ccw";

           					g2d.drawString(s, m_VideoCanvas.getWidth()-g2d.getFontMetrics().stringWidth(s)-10, m_VideoCanvas.getHeight()-8 );
    	       				
    	       				
    	    			}
	    			
	    			}
	    			
       				
	    	    } 
	        	catch( Exception ex )
	        	{
	        		ex.printStackTrace();
	        	}
	    	    finally 
	    	    {
	    	        g.dispose();
	    	    }
	        }
	        while (m_FlipStrategy.contentsRestored());

	        // Display the buffer
	        m_FlipStrategy.show();

	        // Repeat the rendering if the drawing buffer was lost
	    } 
	    while (m_FlipStrategy.contentsLost());
	}
	
	public void update(Graphics g)
	{
		paint(g);		
	}
	
	public void repaintAnything()
	{
		updateImage();
		repaint();
	}
	
	public void paint(Graphics g)
	{
		if (m_bTransferRunning == false) 
		{
			updateImage();
			repaint();
		}
		super.paint(g);
	}

	/*
	private void RepaintCanvas()
	{
		Graphics g = null;
		try {
			if (m_FlipStrategy != null)
			{
				g = (java.awt.Graphics2D) m_FlipStrategy.getDrawGraphics();
				m_VideoCanvas.paint(g);
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace();
		}
		finally
		{
			if (g != null) g.dispose();
		}
	}
	*/
	/**
	 * This method initializes jControlPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJControlPanel() {
		if (jControlPanel == null) {
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 3;
			gridBagConstraints21.insets = new Insets(2, 0, 2, 0);
			gridBagConstraints21.gridheight = 1;
			gridBagConstraints21.gridwidth = 0;
			gridBagConstraints21.ipadx = 0;
			gridBagConstraints21.anchor = GridBagConstraints.EAST;
			gridBagConstraints21.weighty = 1.0;
			gridBagConstraints21.gridy = 2;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 3;
			gridBagConstraints13.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints13.ipadx = 0;
			gridBagConstraints13.ipady = 0;
			gridBagConstraints13.weighty = 1.0;
			gridBagConstraints13.anchor = GridBagConstraints.EAST;
			gridBagConstraints13.gridwidth = 1;
			gridBagConstraints13.gridy = 1;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 3;
			gridBagConstraints10.anchor = GridBagConstraints.EAST;
			gridBagConstraints10.gridy = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 2;
			gridBagConstraints3.gridy = 0;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 2;
			gridBagConstraints7.ipadx = 0;
			gridBagConstraints7.gridy = 2;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 2;
			gridBagConstraints4.gridy = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.ipadx = 13;
			gridBagConstraints2.gridy = 2;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.ipadx = 10;
			gridBagConstraints1.insets = new Insets(0, 0, 6, 0);
			gridBagConstraints1.gridy = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridwidth = 1;
			gridBagConstraints.ipadx = 43;
			gridBagConstraints.insets = new Insets(0, 0, 7, 0);
			gridBagConstraints.gridy = 0;
			jControlPanel = new JPanel();
			jControlPanel.setLayout(new GridBagLayout());
			jControlPanel.setPreferredSize(new Dimension(290, 100));
			jControlPanel.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
			jControlPanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
			jControlPanel.add(getJRBColorGreyscale(), gridBagConstraints);
			jControlPanel.add(getJRBColorPITZ(), gridBagConstraints1);
			jControlPanel.add(getJRBColorJet(), gridBagConstraints2);
			jControlPanel.add(getJControlSubPanel(), gridBagConstraints4);
			jControlPanel.add(getJCBKeepAspectRatio(), gridBagConstraints7);
			jControlPanel.add(getJControlSubPanel2(), gridBagConstraints3);
			jControlPanel.add(getJControlPanel3(), gridBagConstraints10);
			jControlPanel.add(getJBSaveAsPNG(), gridBagConstraints13);
			jControlPanel.add(getJBQuit(), gridBagConstraints21);
		}
		return jControlPanel;
	}

	/**
	 * This method initializes jRBColorGreyscale	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRBColorGreyscale() {
		if (jRBColorGreyscale == null) {
			jRBColorGreyscale = new JRadioButton();
			jRBColorGreyscale.setText("Grayscale");
			jRBColorGreyscale.setHorizontalTextPosition(SwingConstants.TRAILING);
			jRBColorGreyscale.setMnemonic(KeyEvent.VK_UNDEFINED);
			jRBColorGreyscale.setHorizontalAlignment(SwingConstants.LEFT);
			jRBColorGreyscale.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jRBColorPITZ.setSelected(false);
					jRBColorJet.setSelected(false);
					if (jRBColorGreyscale.isSelected() == false) jRBColorGreyscale.setSelected(true);
					m_iColorMode = CColorLookupTable.GRAYSCALE;
					m_bDoUpdateColorLookupTable = true;

					repaint();
				}
			});
		}
		return jRBColorGreyscale;
	}

	/**
	 * This method initializes jRBColorPITZ	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRBColorPITZ() {
		if (jRBColorPITZ == null) {
			jRBColorPITZ = new JRadioButton();
			jRBColorPITZ.setText("PITZ False Color");
			jRBColorPITZ.setMnemonic(KeyEvent.VK_UNDEFINED);
			jRBColorPITZ.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jRBColorJet.setSelected(false);
					jRBColorGreyscale.setSelected(false);
					if (jRBColorPITZ.isSelected() == false) jRBColorPITZ.setSelected(true);
					m_iColorMode = CColorLookupTable.FALSEPITZ;
					m_bDoUpdateColorLookupTable = true;

					repaint();
				}
			});
		}
		return jRBColorPITZ;
	}

	/**
	 * This method initializes jRBColorJet	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRBColorJet() {
		if (jRBColorJet == null) {
			jRBColorJet = new JRadioButton();
			jRBColorJet.setName("");
			jRBColorJet.setText("JET False Color");
			jRBColorJet.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					jRBColorPITZ.setSelected(false);
					jRBColorGreyscale.setSelected(false);
					if (jRBColorJet.isSelected() == false) jRBColorJet.setSelected(true);
					m_iColorMode = CColorLookupTable.FALSEJET;
					m_bDoUpdateColorLookupTable = true;

					repaint();
				}
			});
		}
		return jRBColorJet;
	}

	/**
	 * This method initializes jControlSubPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJControlSubPanel() {
		if (jControlSubPanel == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridwidth = 0;
			gridBagConstraints6.gridheight = 0;
			gridBagConstraints6.gridy = 0;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.ipadx = 57;
			gridBagConstraints5.gridy = 0;
			jControlSubPanel = new JPanel();
			jControlSubPanel.setLayout(new GridBagLayout());
			jControlSubPanel.setPreferredSize(new Dimension(270, 20));
			jControlSubPanel.add(getJCBOverlay(), gridBagConstraints5);
			jControlSubPanel.add(getJCBAOIZoom(), gridBagConstraints6);
		}
		return jControlSubPanel;
	}

	/**
	 * This method initializes jCBOverlay	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCBOverlay() {
		if (jCBOverlay == null) {
			jCBOverlay = new JCheckBox();
			jCBOverlay.setMnemonic(KeyEvent.VK_UNDEFINED);
			jCBOverlay.setText("Overlay always on");
			jCBOverlay.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (m_bOverlayEnabled == true) 
						m_bOverlayEnabled = false; 
					else
						m_bOverlayEnabled = true;

					repaint();
				}
				
			});
		}
		return jCBOverlay;
	}

	/**
	 * This method initializes jCBAOIZoom	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCBAOIZoom() {
		if (jCBAOIZoom == null) {
			jCBAOIZoom = new JCheckBox();
			jCBAOIZoom.setText("AOI Zoom");
			jCBAOIZoom.setMnemonic(KeyEvent.VK_UNDEFINED);
			jCBAOIZoom.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (m_bAOIZoom == true) 
						m_bAOIZoom = false; 
					else
						m_bAOIZoom = true;

					repaint();
				}
				
			});
			
			
		}
		return jCBAOIZoom;
	}

	/**
	 * This method initializes jCBKeepAspectRatio	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCBKeepAspectRatio() {
		if (jCBKeepAspectRatio == null) {
			jCBKeepAspectRatio = new JCheckBox();
			jCBKeepAspectRatio.setMnemonic(KeyEvent.VK_UNDEFINED);
			jCBKeepAspectRatio.setPreferredSize(new Dimension(265, 24));
			jCBKeepAspectRatio.setText("Keep Aspect Ratio");
			jCBKeepAspectRatio.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (m_bKeepAspectRatioEnabled == true) 
						m_bKeepAspectRatioEnabled = false; 
					else
						m_bKeepAspectRatioEnabled = true;
					
					repaint();
				}
			});

		}
		return jCBKeepAspectRatio;
	}

	/**
	 * This method initializes jControlSubPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJControlSubPanel2() {
		if (jControlSubPanel2 == null) {
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints9.gridy = 0;
			gridBagConstraints9.weightx = 1.0;
			gridBagConstraints9.gridx = 1;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 0;
			gridBagConstraints8.anchor = GridBagConstraints.WEST;
			gridBagConstraints8.ipadx = 5;
			gridBagConstraints8.gridy = 0;
			jLabelAddress = new JLabel();
			jLabelAddress.setText("    Address:");
			jControlSubPanel2 = new JPanel();
			jControlSubPanel2.setLayout(new GridBagLayout());
			jControlSubPanel2.setPreferredSize(new Dimension(280, 20));
			jControlSubPanel2.add(jLabelAddress, gridBagConstraints8);
			jControlSubPanel2.add(getJTFAddress(), gridBagConstraints9);
		}
		return jControlSubPanel2;
	}

	/**
	 * This method initializes jTFAddress	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTFAddress() {
		if (jTFAddress == null) {
			jTFAddress = new JTextField();
			jTFAddress.setPreferredSize(new Dimension(200, 20));
			jTFAddress.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) 
			{
				jBStart.doClick();
			}
			});
			
		}
		return jTFAddress;
	}

	/**
	 * This method initializes jControlPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJControlPanel3() {
		if (jControlPanel3 == null) {
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 1;
			gridBagConstraints12.gridheight = 1;
			gridBagConstraints12.ipadx = 0;
			gridBagConstraints12.gridwidth = 1;
			gridBagConstraints12.insets = new Insets(2, 0, 2, 0);
			gridBagConstraints12.anchor = GridBagConstraints.EAST;
			gridBagConstraints12.fill = GridBagConstraints.NONE;
			gridBagConstraints12.weightx = 1.0;
			gridBagConstraints12.weighty = 1.0;
			gridBagConstraints12.gridy = 0;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.weightx = 1.0;
			gridBagConstraints11.weighty = 1.0;
			gridBagConstraints11.gridwidth = 1;
			gridBagConstraints11.insets = new Insets(2, 0, 2, 0);
			gridBagConstraints11.gridy = 0;
			jControlPanel3 = new JPanel();
			jControlPanel3.setLayout(new GridBagLayout());
			jControlPanel3.setPreferredSize(new Dimension(160, 26));
			jControlPanel3.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jControlPanel3.add(getJBStart(), gridBagConstraints11);
			jControlPanel3.add(getJBStop(), gridBagConstraints12);
		}
		return jControlPanel3;
	}

	public void setAlreadyStarted(String aAddress)
	{
		jTFAddress.setText(aAddress);
		jBStop.setEnabled(true);
		jBStart.setEnabled(false);
		jBSaveAsPNG.setEnabled(false);
		jTFAddress.setEditable(false);
	}
	
	/**
	 * This method initializes jBStart	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJBStart() {
		if (jBStart == null) {
			jBStart = new JButton();
			jBStart.setMnemonic(KeyEvent.VK_UNDEFINED);
			jBStart.setText("Start");
			jBStart.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String s = jTFAddress.getText();
					if (doStartTransfer(s, false)==true)
					{
						jBStop.setEnabled(true);
						jBStart.setEnabled(false);
						jBSaveAsPNG.setEnabled(false);
						jTFAddress.setEditable(false);
					}
				}
			});
		}
		return jBStart;
	}

	/**
	 * This method initializes jBStop	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJBStop() {
		if (jBStop == null) {
			jBStop = new JButton();
			jBStop.setMnemonic(KeyEvent.VK_UNDEFINED);
			jBStop.setPreferredSize(new Dimension(62, 26));
			jBStop.setText("Stop");
			jBStop.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{
					doStopTransfer();
					jBStop.setEnabled(false);
					jBStart.setEnabled(true);
					jBSaveAsPNG.setEnabled(true);
					jTFAddress.setEditable(true);
					
				}
			});
		}
		return jBStop;
	}

	/**
	 * This method initializes jBSaveAsPNG	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJBSaveAsPNG() {
		if (jBSaveAsPNG == null) {
			jBSaveAsPNG = new JButton();
			jBSaveAsPNG.setMnemonic(KeyEvent.VK_UNDEFINED);
			jBSaveAsPNG.setText("Save As PNG...");
			jBSaveAsPNG.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{
				
					JFileChooser chooser = new JFileChooser(new File("."));
				    
					String[] fileType= {"png"};
					
					FileNameExtensionFilter PNGfilter = new FileNameExtensionFilter(
				        "PNG files", fileType);
				    
				    chooser.addChoosableFileFilter(PNGfilter);
				    
				    int returnVal = chooser.showSaveDialog(m_selfRef);
				    
				    if (returnVal == JFileChooser.APPROVE_OPTION) 
				    {
						String fileNamePath = chooser.getSelectedFile().getAbsolutePath();

						boolean ret = CBasicPNGWriterV3.write(fileNamePath, m_img, m_Hdr);
						if (ret == false)
						{
							JOptionPane.showMessageDialog(m_selfRef, 
									new String("Error saving image."),"", JOptionPane.ERROR_MESSAGE );
						}
					}

					repaint();

				}
			});
		}
		return jBSaveAsPNG;
	}

	/**
	 * This method initializes jBQuit	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJBQuit() {
		if (jBQuit == null) {
			jBQuit = new JButton();
			jBQuit.setMnemonic(KeyEvent.VK_UNDEFINED);
			jBQuit.setText("Quit");
			jBQuit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					QuitCleanupApplication();
				}
			});
		}
		return jBQuit;
	}

	////////////////////////////////////////////////////////////////////////////
	//TINE handling
	////////////////////////////////////////////////////////////////////////////
	public boolean ProbeTine(String aDevName, String aDevProp)
	{
		boolean retval = true;
		int cc;
				
		byte[] framebits = new byte[CVideoHeader3.HDRSIZE]; 
		//	1 meg max frame size, e.g. 800x624 x 2 bypp + header
		// if bigger than server max work area size, then error 30 
		// (invalid transport)
		
		TDataType dout = new TDataType(framebits);
		
	    // get a reference array : synchronous call ...
	    TLink ref = new TLink(aDevName,aDevProp,dout,null,TAccess.CA_READ);
	    cc=ref.execute();
	    if (cc != 0) 
	    {
	    	//System.out.println("Error: get reference : " + ref.getLinkStatus());
	    	// 517==RETCODE_NOFRAMEYET
	    	JOptionPane.showMessageDialog(this, 
	    			new String("Probing Address did not succeed.\n\n"+
	    						"Transfer was cancelled."),"Checking connection...", JOptionPane.ERROR_MESSAGE );
	    	retval = false;
	    }
	    else
	    {
	    	ref.cancel();
	    	//System.out.println("Got "+dout.dCompletionLength+" bytes back.");
	    	if (dout.dCompletionLength != CVideoHeader3.HDRSIZE)
	    	{
		    	JOptionPane.showMessageDialog(this, 
		    			new String("CF_IMAGE header is not 172 bytes in size.\n\n"+
		    						"Transfer was cancelled."),"Checking connection...", JOptionPane.ERROR_MESSAGE );
	    	}
	    }
	    
	    framebits = null;
	    				
		return retval;
	}

	
	public boolean doStartTransfer(String aCmdLine, boolean aCommandLine)
	{
		String devName = aCmdLine;  // /context/server/device;
		String devProp = "Frame.Sched";
		
		if (aCommandLine == true) jTFAddress.setText(devName);
		
		if (devName.endsWith("/") == true) devName += "Output";
		
		if (ProbeTine(devName, "Header") == false) return false;
		
		//buffer must be dividable by four
		// 192 = 188 headerbytes + (dividable by 8)
		if (m_srcBuf == null)
			m_srcBuf = new byte[1024*1024*6+192];
   
		m_srcImgHdr = new IMAGE();
	    m_srcImgHdr.setImageFrameBuffer(m_srcBuf);
	    
	    TDataType img_dout = new TDataType(m_srcImgHdr);
		
		m_vidLink = new TLink(devName,devProp,img_dout,null,TAccess.CA_READ);
	    if (m_vidLink.attach(TMode.CM_POLL, this, 1000) < 0)
	    {
	      m_vidLink.cancel();
	      m_vidLink = null;
    	  
	      JOptionPane.showMessageDialog(this, 
	    			new String("No permanent connection to server (\""+m_vidLink.getLastError()+"\".\n\n"+
	    						"Transfer was cancelled."),"Establishing connection...", JOptionPane.ERROR_MESSAGE );
	      
	      return false;
	    }

	    m_img=null;
		m_mis=null;
		
		m_DisplayImageBuffer = null;
		m_ColorLookupTableArray = null;
		m_bDoUpdateColorLookupTable = true;
		m_lastframenumber=-1;
		m_droppedframes=0;
		m_receivedframes=0;
		m_ratio = -0.001;
				
	    m_bTransferRunning = true;
			
		return true;
	}
	
	public boolean doStopTransfer()
	{
		if (m_vidLink != null)
		{
			m_vidLink.cancel();
			m_vidLink = null;
		}

		//m_srcBuf = null;
		//m_dstBuf = null;

		m_bTransferRunning = false;		
	
		return true;
	}
	
	public synchronized void updateHeader(CVideoHeader3 aHdr)
	{
		m_Hdr = aHdr;
	}
	
    public synchronized void callback(TLink lnk)
    {
    	if (m_bTransferRunning == false) return;

    	if (lnk.getLinkStatus() == 516) return;
	   	
    	if (lnk.getLinkStatus() != 0 )
	    {
	        System.out.println("Link Error : code="+lnk.getLinkStatus()+ " msg="+ lnk.getLastError());
	        return;
	    }
    	
    	CVideoHeader3 hdr = new CVideoHeader3(m_srcImgHdr);
    	//adjust into raw bits
      	
   		int pixellength = hdr.getAppendedWidth()*hdr.getAppendedHeight();
   		int uncompressed_byte_length = pixellength * hdr.frameHeader.bytesPerPixel;

   		if (m_DisplayImageBuffer == null)
		{
			m_DisplayImageBuffer = new int[pixellength];
		}
		else if (m_DisplayImageBuffer.length < pixellength)
		{
			m_DisplayImageBuffer = null;
			m_DisplayImageBuffer = new int[pixellength];
		}
    		
   		if (hdr.frameHeader.imageFormat == CVideoHeader3.CF_IMAGE_FORMAT_GRAY)
   		{
   			if ((m_dstBuf == null) || (m_dstBuf.length < uncompressed_byte_length)) m_dstBuf = new byte[uncompressed_byte_length];

   			if (convertImage(m_srcBuf, hdr, m_dstBuf) == false) 
   			{
   				System.out.println("convertImage false");
   				return;
   			}

   			if (m_bFalsecolorEnabled == false)
   			{
   				// enable false color switching in gui
   				jRBColorPITZ.setEnabled(true);
   				jRBColorJet.setEnabled(true);
   				jRBColorGreyscale.setEnabled(true);
    				
   				m_bFalsecolorEnabled = true;
   			}
    			
   			//System.out.println("Image #"+hdr.framenumber+" received.");

			if ((m_ColorLookupTableArray == null) || (m_ColorLookupTableArray.length < (hdr.frameHeader.bytesPerPixel << 8)) )
			{
				m_bDoUpdateColorLookupTable = true;
  			}
   			
   			if (m_bDoUpdateColorLookupTable == true)
   			{
   				boolean ret = m_CColorLookupTable.AdjustTable(m_iColorMode, hdr.frameHeader.bytesPerPixel, hdr.frameHeader.effectiveBitsPerPixel);
   				if ((ret == true) || (m_ColorLookupTableArray == null)) m_ColorLookupTableArray = m_CColorLookupTable.getColorLookupTable(); 
   				m_bDoUpdateColorLookupTable = false;
   			}
    			
   			int maxcol = (1<<hdr.frameHeader.effectiveBitsPerPixel)-1;
   			int index=0;
   			try {
   				// not only 8bpp by now (but not "perfect")
   				// todo	make faster
   				while( index < pixellength )
   				{
   					if (hdr.frameHeader.bytesPerPixel == 1)
   						m_DisplayImageBuffer[index] = m_ColorLookupTableArray[((int)m_dstBuf[index])&maxcol];

   					if (hdr.frameHeader.bytesPerPixel == 2)
   					{
   						int tmp;
   						int clutindex=0;
										
   						clutindex = (((int)m_dstBuf[2*index])&0xff);
   						tmp = ((((int)m_dstBuf[2*index+1]))&0xff)<<8;
						
   						// &maxcol
   						m_DisplayImageBuffer[index] = m_ColorLookupTableArray[tmp+clutindex];
   					}
										
   					index++;
   				}
   			} catch( ArrayIndexOutOfBoundsException ex) {}
    			
   		}
   		else // can only be RGB now
   		{
   			if (m_bFalsecolorEnabled == true)
   			{
   				// disable false color switching in gui
   				jRBColorPITZ.setEnabled(false);
   				jRBColorJet.setEnabled(false);
   				jRBColorGreyscale.setEnabled(false);

   				m_bFalsecolorEnabled = false;
   			}

   			if ((m_dstBuf == null) || (m_dstBuf.length < uncompressed_byte_length)) m_dstBuf = new byte[uncompressed_byte_length];
    			
   			// rgb24
   			if (convertImageColor(m_srcBuf, m_dstBuf, hdr, m_DisplayImageBuffer) == false) 
   			{
   				System.out.println("convertImageColor false");
   				return;
   			}
   		}

		if (m_mis == null)
		{
			m_mis = new MemoryImageSource(hdr.getAppendedWidth(), hdr.getAppendedHeight(), m_DisplayImageBuffer, 0, hdr.getAppendedWidth());
			m_mis.setAnimated(true);
			m_mis.setFullBufferUpdates(true);
		}
			
		if (m_img == null)
		{
			m_img = Toolkit.getDefaultToolkit().createImage(m_mis);
		}
			
		m_mis.newPixels();
			
		// calculate variables
			
		if (m_lastframenumber == -1)
		{
			m_lastframenumber = hdr.frameHeader.frameNumber;
			m_droppedframes = 0;
			m_receivedframes++;
		}
		else
		{
			if (hdr.frameHeader.frameNumber == m_lastframenumber)
			{
				System.out.println("Theyre same: "+hdr.frameHeader.frameNumber+"  "+m_lastframenumber+" !");
			}
			else if( hdr.frameHeader.frameNumber < m_lastframenumber)
			{
				m_receivedframes++;
			}
			else
			{
				m_droppedframes += (hdr.frameHeader.frameNumber-m_lastframenumber-1);
				m_receivedframes++;
			}
			m_lastframenumber = hdr.frameHeader.frameNumber;
				
		}

		if (m_receivedframes != 0)
			m_ratio = ((1.0*m_droppedframes) / (1.0*(m_receivedframes)));
			
		if (m_img != null) 
		{
			updateHeader(hdr);
			updateImage();
		}
   	}
	
	
	////////////////////////////////////////////////////////////////////////////////
	// frame decode handling
	////////////////////////////////////////////////////////////////////////////////
    
	public boolean convertImage(byte[] aSrc, CVideoHeader3 aHdr, byte[] aDst)
	{
		int uncompressed_size = aHdr.getAppendedWidth()*aHdr.getAppendedHeight()*aHdr.frameHeader.bytesPerPixel;
			
		if ((aSrc == null) || (aDst == null) || (aDst.length < uncompressed_size)) return false;

		if (aHdr.frameHeader.sourceFormat == CVideoHeader3.CF_IMAGE_FORMAT_GRAY)
		{
			if (aHdr.frameHeader.imageFormat != aHdr.frameHeader.sourceFormat)
			{
				// only HuffYUV is supported here as decompression
				if (aHdr.frameHeader.imageFormat != CVideoHeader3.CF_IMAGE_FORMAT_HUFFYUV) return false;

				CHuffmanDecompression.DecompressHuffYUV(aSrc, CVideoHeader3.HDRSIZE, aDst, 0, uncompressed_size);
					
				// adjust header after compression
				aHdr.frameHeader.imageFormat = aHdr.frameHeader.sourceFormat;
				aHdr.sourceHeader.totalLength = uncompressed_size+CVideoHeader3.HDRSIZE;
				aHdr.frameHeader.appendedFrameSize = uncompressed_size;
			}
			else
			{
				//System.arraycopy(aSrc, CVideoHeader3.HDRSIZE, aDst, 0, (int) aHdr.frameHeader.appendedFrameSize);
				System.arraycopy(aSrc, 0, aDst, 0, (int) aHdr.frameHeader.appendedFrameSize);
			}			
		}
		else
		{
			 return false;
		}
			
		return true;
	}

	public boolean convertImageColor(byte[] aSrc, byte[] aDstRaw, CVideoHeader3 aHdr, int[] aDst)
	{
		int uncompressed_pixel_size = aHdr.getAppendedWidth()*aHdr.getAppendedHeight();
			
		if ((aSrc == null) || (aDst == null) || (aDst.length < uncompressed_pixel_size)) return false;
		if ((aDstRaw == null) || (aDstRaw.length < uncompressed_pixel_size*aHdr.frameHeader.bytesPerPixel)) return false;

		if (aHdr.frameHeader.imageFormat != CVideoHeader3.CF_IMAGE_FORMAT_RGB)
		{
			return false;
		}
		int index=0;
		int index1=0;

		try {
		while( index < uncompressed_pixel_size)
		{
			int red16 = (((int) aSrc[index1++])&0xFF);
			int green8 = (((int) aSrc[index1++])&0xFF);
			int blue = (((int) aSrc[index1++])&0xFF);
			
			aDst[index++] = 0xFF000000 | (red16 << 16) | (green8 << 8) | (blue);
			//  
		}
		} catch( ArrayIndexOutOfBoundsException ex) {}

		System.arraycopy(aSrc, 0, aDstRaw, 0, aHdr.frameHeader.appendedFrameSize);
		//System.arraycopy(aSrc, CVideoHeader3.HDRSIZE, aDstRaw, 0, (int) aHdr.imH_length);
		
		return true;
	}
	
	
}  //  @jve:decl-index=0:visual-constraint="21,28"
